package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class AnnotationBuilder extends AnnotationFluentImpl<AnnotationBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.Annotation,AnnotationBuilder>{

    AnnotationFluent<?> fluent;
    Boolean validationEnabled;

    public AnnotationBuilder(){
            this(true);
    }
    public AnnotationBuilder(Boolean validationEnabled){
            this(new Annotation(), validationEnabled);
    }
    public AnnotationBuilder(AnnotationFluent<?> fluent){
            this(fluent, true);
    }
    public AnnotationBuilder(AnnotationFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Annotation(), validationEnabled);
    }
    public AnnotationBuilder(AnnotationFluent<?> fluent,io.dekorate.kubernetes.config.Annotation instance){
            this(fluent, instance, true);
    }
    public AnnotationBuilder(AnnotationFluent<?> fluent,io.dekorate.kubernetes.config.Annotation instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withKey(instance.getKey()); 
            fluent.withValue(instance.getValue()); 
            this.validationEnabled = validationEnabled; 
    }
    public AnnotationBuilder(io.dekorate.kubernetes.config.Annotation instance){
            this(instance,true);
    }
    public AnnotationBuilder(io.dekorate.kubernetes.config.Annotation instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withKey(instance.getKey()); 
            this.withValue(instance.getValue()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableAnnotation build(){
            EditableAnnotation buildable = new EditableAnnotation(fluent.getKey(),fluent.getValue());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            AnnotationBuilder that = (AnnotationBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
