package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class ApplicationConfigurationBuilder extends ApplicationConfigurationFluentImpl<ApplicationConfigurationBuilder> implements VisitableBuilder<ApplicationConfiguration,ApplicationConfigurationBuilder>{

    ApplicationConfigurationFluent<?> fluent;
    Boolean validationEnabled;

    public ApplicationConfigurationBuilder(){
            this(true);
    }
    public ApplicationConfigurationBuilder(Boolean validationEnabled){
            this(new ApplicationConfiguration(), validationEnabled);
    }
    public ApplicationConfigurationBuilder(ApplicationConfigurationFluent<?> fluent){
            this(fluent, true);
    }
    public ApplicationConfigurationBuilder(ApplicationConfigurationFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new ApplicationConfiguration(), validationEnabled);
    }
    public ApplicationConfigurationBuilder(ApplicationConfigurationFluent<?> fluent,ApplicationConfiguration instance){
            this(fluent, instance, true);
    }
    public ApplicationConfigurationBuilder(ApplicationConfigurationFluent<?> fluent,ApplicationConfiguration instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withProject(instance.getProject()); 
            fluent.withAttributes(instance.getAttributes()); 
            fluent.withGroup(instance.getGroup()); 
            fluent.withName(instance.getName()); 
            fluent.withVersion(instance.getVersion()); 
            this.validationEnabled = validationEnabled; 
    }
    public ApplicationConfigurationBuilder(ApplicationConfiguration instance){
            this(instance,true);
    }
    public ApplicationConfigurationBuilder(ApplicationConfiguration instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withProject(instance.getProject()); 
            this.withAttributes(instance.getAttributes()); 
            this.withGroup(instance.getGroup()); 
            this.withName(instance.getName()); 
            this.withVersion(instance.getVersion()); 
            this.validationEnabled = validationEnabled; 
    }

    public io.dekorate.kubernetes.config.EditableApplicationConfiguration build(){
            EditableApplicationConfiguration buildable = new EditableApplicationConfiguration(fluent.getProject(),fluent.getAttributes(),fluent.getGroup(),fluent.getName(),fluent.getVersion());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ApplicationConfigurationBuilder that = (ApplicationConfigurationBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
