package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class AwsElasticBlockStoreVolumeBuilder extends AwsElasticBlockStoreVolumeFluentImpl<AwsElasticBlockStoreVolumeBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume,AwsElasticBlockStoreVolumeBuilder>{

    AwsElasticBlockStoreVolumeFluent<?> fluent;
    Boolean validationEnabled;

    public AwsElasticBlockStoreVolumeBuilder(){
            this(true);
    }
    public AwsElasticBlockStoreVolumeBuilder(Boolean validationEnabled){
            this(new AwsElasticBlockStoreVolume(), validationEnabled);
    }
    public AwsElasticBlockStoreVolumeBuilder(AwsElasticBlockStoreVolumeFluent<?> fluent){
            this(fluent, true);
    }
    public AwsElasticBlockStoreVolumeBuilder(AwsElasticBlockStoreVolumeFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new AwsElasticBlockStoreVolume(), validationEnabled);
    }
    public AwsElasticBlockStoreVolumeBuilder(AwsElasticBlockStoreVolumeFluent<?> fluent,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume instance){
            this(fluent, instance, true);
    }
    public AwsElasticBlockStoreVolumeBuilder(AwsElasticBlockStoreVolumeFluent<?> fluent,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withVolumeName(instance.getVolumeName()); 
            fluent.withVolumeId(instance.getVolumeId()); 
            fluent.withPartition(instance.getPartition()); 
            fluent.withFsType(instance.getFsType()); 
            fluent.withReadOnly(instance.isReadOnly()); 
            this.validationEnabled = validationEnabled; 
    }
    public AwsElasticBlockStoreVolumeBuilder(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume instance){
            this(instance,true);
    }
    public AwsElasticBlockStoreVolumeBuilder(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withVolumeName(instance.getVolumeName()); 
            this.withVolumeId(instance.getVolumeId()); 
            this.withPartition(instance.getPartition()); 
            this.withFsType(instance.getFsType()); 
            this.withReadOnly(instance.isReadOnly()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableAwsElasticBlockStoreVolume build(){
            EditableAwsElasticBlockStoreVolume buildable = new EditableAwsElasticBlockStoreVolume(fluent.getVolumeName(),fluent.getVolumeId(),fluent.getPartition(),fluent.getFsType(),fluent.isReadOnly());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            AwsElasticBlockStoreVolumeBuilder that = (AwsElasticBlockStoreVolumeBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
