package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class AzureFileVolumeBuilder extends AzureFileVolumeFluentImpl<AzureFileVolumeBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.AzureFileVolume,AzureFileVolumeBuilder>{

    AzureFileVolumeFluent<?> fluent;
    Boolean validationEnabled;

    public AzureFileVolumeBuilder(){
            this(true);
    }
    public AzureFileVolumeBuilder(Boolean validationEnabled){
            this(new AzureFileVolume(), validationEnabled);
    }
    public AzureFileVolumeBuilder(AzureFileVolumeFluent<?> fluent){
            this(fluent, true);
    }
    public AzureFileVolumeBuilder(AzureFileVolumeFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new AzureFileVolume(), validationEnabled);
    }
    public AzureFileVolumeBuilder(AzureFileVolumeFluent<?> fluent,io.dekorate.kubernetes.config.AzureFileVolume instance){
            this(fluent, instance, true);
    }
    public AzureFileVolumeBuilder(AzureFileVolumeFluent<?> fluent,io.dekorate.kubernetes.config.AzureFileVolume instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withVolumeName(instance.getVolumeName()); 
            fluent.withShareName(instance.getShareName()); 
            fluent.withSecretName(instance.getSecretName()); 
            fluent.withReadOnly(instance.isReadOnly()); 
            this.validationEnabled = validationEnabled; 
    }
    public AzureFileVolumeBuilder(io.dekorate.kubernetes.config.AzureFileVolume instance){
            this(instance,true);
    }
    public AzureFileVolumeBuilder(io.dekorate.kubernetes.config.AzureFileVolume instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withVolumeName(instance.getVolumeName()); 
            this.withShareName(instance.getShareName()); 
            this.withSecretName(instance.getSecretName()); 
            this.withReadOnly(instance.isReadOnly()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableAzureFileVolume build(){
            EditableAzureFileVolume buildable = new EditableAzureFileVolume(fluent.getVolumeName(),fluent.getShareName(),fluent.getSecretName(),fluent.isReadOnly());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            AzureFileVolumeBuilder that = (AzureFileVolumeBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
