package io.dekorate.kubernetes.config;

import java.lang.String;
import io.dekorate.project.Project;
import io.dekorate.kubernetes.annotation.ImagePullPolicy;
import io.dekorate.kubernetes.annotation.ServiceType;
import java.lang.Object;
import java.util.Map;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class BaseConfig extends ApplicationConfiguration{

    private io.dekorate.kubernetes.config.Container[] initContainers = new io.dekorate.kubernetes.config.Container[0];
    private io.dekorate.kubernetes.config.Label[] labels = new io.dekorate.kubernetes.config.Label[0];
    private io.dekorate.kubernetes.config.Annotation[] annotations = new io.dekorate.kubernetes.config.Annotation[0];
    private io.dekorate.kubernetes.config.Env[] envVars = new io.dekorate.kubernetes.config.Env[0];
    private String workingDir = "";
    private String[] command = new java.lang.String[0];
    private String[] arguments = new java.lang.String[0];
    private int replicas = 1;
    private String serviceAccount = "";
    private String host = "";
    private io.dekorate.kubernetes.config.Port[] ports = new io.dekorate.kubernetes.config.Port[0];
    private ServiceType serviceType = io.dekorate.kubernetes.annotation.ServiceType.ClusterIP;
    private io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] pvcVolumes = new io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[0];
    private io.dekorate.kubernetes.config.SecretVolume[] secretVolumes = new io.dekorate.kubernetes.config.SecretVolume[0];
    private io.dekorate.kubernetes.config.ConfigMapVolume[] configMapVolumes = new io.dekorate.kubernetes.config.ConfigMapVolume[0];
    private io.dekorate.kubernetes.config.GitRepoVolume[] gitRepoVolumes = new io.dekorate.kubernetes.config.GitRepoVolume[0];
    private io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] awsElasticBlockStoreVolumes = new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[0];
    private io.dekorate.kubernetes.config.AzureDiskVolume[] azureDiskVolumes = new io.dekorate.kubernetes.config.AzureDiskVolume[0];
    private io.dekorate.kubernetes.config.AzureFileVolume[] azureFileVolumes = new io.dekorate.kubernetes.config.AzureFileVolume[0];
    private io.dekorate.kubernetes.config.Mount[] mounts = new io.dekorate.kubernetes.config.Mount[0];
    private ImagePullPolicy imagePullPolicy = io.dekorate.kubernetes.annotation.ImagePullPolicy.IfNotPresent;
    private String[] imagePullSecrets = new java.lang.String[0];
    private io.dekorate.kubernetes.config.Probe livenessProbe = null;
    private io.dekorate.kubernetes.config.Probe readinessProbe = null;
    private io.dekorate.kubernetes.config.Container[] sidecars = new io.dekorate.kubernetes.config.Container[0];
    private boolean expose = false;
    private boolean autoDeployEnabled = false;

    public BaseConfig(){
    }
    public BaseConfig(Project project,Map<ConfigKey,Object> attributes,String group,String name,String version,io.dekorate.kubernetes.config.Container[] initContainers,io.dekorate.kubernetes.config.Label[] labels,io.dekorate.kubernetes.config.Annotation[] annotations,io.dekorate.kubernetes.config.Env[] envVars,String workingDir,String[] command,String[] arguments,int replicas,String serviceAccount,String host,io.dekorate.kubernetes.config.Port[] ports,ServiceType serviceType,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] pvcVolumes,io.dekorate.kubernetes.config.SecretVolume[] secretVolumes,io.dekorate.kubernetes.config.ConfigMapVolume[] configMapVolumes,io.dekorate.kubernetes.config.GitRepoVolume[] gitRepoVolumes,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] awsElasticBlockStoreVolumes,io.dekorate.kubernetes.config.AzureDiskVolume[] azureDiskVolumes,io.dekorate.kubernetes.config.AzureFileVolume[] azureFileVolumes,io.dekorate.kubernetes.config.Mount[] mounts,ImagePullPolicy imagePullPolicy,String[] imagePullSecrets,io.dekorate.kubernetes.config.Probe livenessProbe,io.dekorate.kubernetes.config.Probe readinessProbe,io.dekorate.kubernetes.config.Container[] sidecars,boolean expose,boolean autoDeployEnabled){
            super(project, attributes, group, name, version);
            this.initContainers = initContainers != null ? initContainers : new io.dekorate.kubernetes.config.Container[0];
            this.labels = labels != null ? labels : new io.dekorate.kubernetes.config.Label[0];
            this.annotations = annotations != null ? annotations : new io.dekorate.kubernetes.config.Annotation[0];
            this.envVars = envVars != null ? envVars : new io.dekorate.kubernetes.config.Env[0];
            this.workingDir = workingDir != null ? workingDir : "";
            this.command = command != null ? command : new java.lang.String[0];
            this.arguments = arguments != null ? arguments : new java.lang.String[0];
            this.replicas = replicas;
            this.serviceAccount = serviceAccount != null ? serviceAccount : "";
            this.host = host != null ? host : "";
            this.ports = ports != null ? ports : new io.dekorate.kubernetes.config.Port[0];
            this.serviceType = serviceType != null ? serviceType : io.dekorate.kubernetes.annotation.ServiceType.ClusterIP;
            this.pvcVolumes = pvcVolumes != null ? pvcVolumes : new io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[0];
            this.secretVolumes = secretVolumes != null ? secretVolumes : new io.dekorate.kubernetes.config.SecretVolume[0];
            this.configMapVolumes = configMapVolumes != null ? configMapVolumes : new io.dekorate.kubernetes.config.ConfigMapVolume[0];
            this.gitRepoVolumes = gitRepoVolumes != null ? gitRepoVolumes : new io.dekorate.kubernetes.config.GitRepoVolume[0];
            this.awsElasticBlockStoreVolumes = awsElasticBlockStoreVolumes != null ? awsElasticBlockStoreVolumes : new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[0];
            this.azureDiskVolumes = azureDiskVolumes != null ? azureDiskVolumes : new io.dekorate.kubernetes.config.AzureDiskVolume[0];
            this.azureFileVolumes = azureFileVolumes != null ? azureFileVolumes : new io.dekorate.kubernetes.config.AzureFileVolume[0];
            this.mounts = mounts != null ? mounts : new io.dekorate.kubernetes.config.Mount[0];
            this.imagePullPolicy = imagePullPolicy != null ? imagePullPolicy : io.dekorate.kubernetes.annotation.ImagePullPolicy.IfNotPresent;
            this.imagePullSecrets = imagePullSecrets != null ? imagePullSecrets : new java.lang.String[0];
            this.livenessProbe = livenessProbe != null ? livenessProbe : null;
            this.readinessProbe = readinessProbe != null ? readinessProbe : null;
            this.sidecars = sidecars != null ? sidecars : new io.dekorate.kubernetes.config.Container[0];
            this.expose = expose;
            this.autoDeployEnabled = autoDeployEnabled;
    }

    public io.dekorate.kubernetes.config.Container[] getInitContainers(){
            return this.initContainers;
    }

    public io.dekorate.kubernetes.config.Label[] getLabels(){
            return this.labels;
    }

    public io.dekorate.kubernetes.config.Annotation[] getAnnotations(){
            return this.annotations;
    }

    public io.dekorate.kubernetes.config.Env[] getEnvVars(){
            return this.envVars;
    }

    public String getWorkingDir(){
            return this.workingDir;
    }

    public String[] getCommand(){
            return this.command;
    }

    public String[] getArguments(){
            return this.arguments;
    }

    public int getReplicas(){
            return this.replicas;
    }

    public String getServiceAccount(){
            return this.serviceAccount;
    }

    public String getHost(){
            return this.host;
    }

    public io.dekorate.kubernetes.config.Port[] getPorts(){
            return this.ports;
    }

    public ServiceType getServiceType(){
            return this.serviceType;
    }

    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] getPvcVolumes(){
            return this.pvcVolumes;
    }

    public io.dekorate.kubernetes.config.SecretVolume[] getSecretVolumes(){
            return this.secretVolumes;
    }

    public io.dekorate.kubernetes.config.ConfigMapVolume[] getConfigMapVolumes(){
            return this.configMapVolumes;
    }

    public io.dekorate.kubernetes.config.GitRepoVolume[] getGitRepoVolumes(){
            return this.gitRepoVolumes;
    }

    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] getAwsElasticBlockStoreVolumes(){
            return this.awsElasticBlockStoreVolumes;
    }

    public io.dekorate.kubernetes.config.AzureDiskVolume[] getAzureDiskVolumes(){
            return this.azureDiskVolumes;
    }

    public io.dekorate.kubernetes.config.AzureFileVolume[] getAzureFileVolumes(){
            return this.azureFileVolumes;
    }

    public io.dekorate.kubernetes.config.Mount[] getMounts(){
            return this.mounts;
    }

    public ImagePullPolicy getImagePullPolicy(){
            return this.imagePullPolicy;
    }

    public String[] getImagePullSecrets(){
            return this.imagePullSecrets;
    }

    public io.dekorate.kubernetes.config.Probe getLivenessProbe(){
            return this.livenessProbe;
    }

    public io.dekorate.kubernetes.config.Probe getReadinessProbe(){
            return this.readinessProbe;
    }

    public io.dekorate.kubernetes.config.Container[] getSidecars(){
            return this.sidecars;
    }

    public boolean isExpose(){
            return this.expose;
    }

    public boolean isAutoDeployEnabled(){
            return this.autoDeployEnabled;
    }




}
