package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import io.dekorate.kubernetes.annotation.ServiceType;
import java.lang.Boolean;
import io.dekorate.project.Project;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.lang.Deprecated;
import java.util.Iterator;
import java.lang.StringBuffer;
import io.dekorate.kubernetes.annotation.ImagePullPolicy;

public interface BaseConfigFluent<A extends BaseConfigFluent<A>> extends ApplicationConfigurationFluent<A>{


    public A withInitContainers(io.dekorate.kubernetes.config.Container... initContainers);
    
/**
 * This method has been deprecated, please use method buildInitContainers instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Container[] getInitContainers();
    public io.dekorate.kubernetes.config.Container[] buildInitContainers();
    public io.dekorate.kubernetes.config.Container buildInitContainer(int index);
    public io.dekorate.kubernetes.config.Container buildFirstInitContainer();
    public io.dekorate.kubernetes.config.Container buildLastInitContainer();
    public io.dekorate.kubernetes.config.Container buildMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public Boolean hasMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public A addToInitContainers(int index,io.dekorate.kubernetes.config.Container item);
    public A setToInitContainers(int index,io.dekorate.kubernetes.config.Container item);
    public A addToInitContainers(io.dekorate.kubernetes.config.Container... items);
    public A addAllToInitContainers(Collection<io.dekorate.kubernetes.config.Container> items);
    public A removeFromInitContainers(io.dekorate.kubernetes.config.Container... items);
    public A removeAllFromInitContainers(Collection<io.dekorate.kubernetes.config.Container> items);
    public A removeMatchingFromInitContainers(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public Boolean hasInitContainers();
    public BaseConfigFluent.InitContainersNested<A> addNewInitContainer();
    public BaseConfigFluent.InitContainersNested<A> addNewInitContainerLike(io.dekorate.kubernetes.config.Container item);
    public BaseConfigFluent.InitContainersNested<A> setNewInitContainerLike(int index,io.dekorate.kubernetes.config.Container item);
    public BaseConfigFluent.InitContainersNested<A> editInitContainer(int index);
    public BaseConfigFluent.InitContainersNested<A> editFirstInitContainer();
    public BaseConfigFluent.InitContainersNested<A> editLastInitContainer();
    public BaseConfigFluent.InitContainersNested<A> editMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public A withLabels(io.dekorate.kubernetes.config.Label... labels);
    
/**
 * This method has been deprecated, please use method buildLabels instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Label[] getLabels();
    public io.dekorate.kubernetes.config.Label[] buildLabels();
    public io.dekorate.kubernetes.config.Label buildLabel(int index);
    public io.dekorate.kubernetes.config.Label buildFirstLabel();
    public io.dekorate.kubernetes.config.Label buildLastLabel();
    public io.dekorate.kubernetes.config.Label buildMatchingLabel(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate);
    public Boolean hasMatchingLabel(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate);
    public A addToLabels(int index,io.dekorate.kubernetes.config.Label item);
    public A setToLabels(int index,io.dekorate.kubernetes.config.Label item);
    public A addToLabels(io.dekorate.kubernetes.config.Label... items);
    public A addAllToLabels(Collection<io.dekorate.kubernetes.config.Label> items);
    public A removeFromLabels(io.dekorate.kubernetes.config.Label... items);
    public A removeAllFromLabels(Collection<io.dekorate.kubernetes.config.Label> items);
    public A removeMatchingFromLabels(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate);
    public Boolean hasLabels();
    public A addNewLabel(String key,String value);
    public BaseConfigFluent.LabelsNested<A> addNewLabel();
    public BaseConfigFluent.LabelsNested<A> addNewLabelLike(io.dekorate.kubernetes.config.Label item);
    public BaseConfigFluent.LabelsNested<A> setNewLabelLike(int index,io.dekorate.kubernetes.config.Label item);
    public BaseConfigFluent.LabelsNested<A> editLabel(int index);
    public BaseConfigFluent.LabelsNested<A> editFirstLabel();
    public BaseConfigFluent.LabelsNested<A> editLastLabel();
    public BaseConfigFluent.LabelsNested<A> editMatchingLabel(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate);
    public A withAnnotations(io.dekorate.kubernetes.config.Annotation... annotations);
    
/**
 * This method has been deprecated, please use method buildAnnotations instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Annotation[] getAnnotations();
    public io.dekorate.kubernetes.config.Annotation[] buildAnnotations();
    public io.dekorate.kubernetes.config.Annotation buildAnnotation(int index);
    public io.dekorate.kubernetes.config.Annotation buildFirstAnnotation();
    public io.dekorate.kubernetes.config.Annotation buildLastAnnotation();
    public io.dekorate.kubernetes.config.Annotation buildMatchingAnnotation(io.dekorate.deps.kubernetes.api.builder.Predicate<AnnotationBuilder> predicate);
    public Boolean hasMatchingAnnotation(io.dekorate.deps.kubernetes.api.builder.Predicate<AnnotationBuilder> predicate);
    public A addToAnnotations(int index,io.dekorate.kubernetes.config.Annotation item);
    public A setToAnnotations(int index,io.dekorate.kubernetes.config.Annotation item);
    public A addToAnnotations(io.dekorate.kubernetes.config.Annotation... items);
    public A addAllToAnnotations(Collection<io.dekorate.kubernetes.config.Annotation> items);
    public A removeFromAnnotations(io.dekorate.kubernetes.config.Annotation... items);
    public A removeAllFromAnnotations(Collection<io.dekorate.kubernetes.config.Annotation> items);
    public A removeMatchingFromAnnotations(io.dekorate.deps.kubernetes.api.builder.Predicate<AnnotationBuilder> predicate);
    public Boolean hasAnnotations();
    public A addNewAnnotation(String key,String value);
    public BaseConfigFluent.AnnotationsNested<A> addNewAnnotation();
    public BaseConfigFluent.AnnotationsNested<A> addNewAnnotationLike(io.dekorate.kubernetes.config.Annotation item);
    public BaseConfigFluent.AnnotationsNested<A> setNewAnnotationLike(int index,io.dekorate.kubernetes.config.Annotation item);
    public BaseConfigFluent.AnnotationsNested<A> editAnnotation(int index);
    public BaseConfigFluent.AnnotationsNested<A> editFirstAnnotation();
    public BaseConfigFluent.AnnotationsNested<A> editLastAnnotation();
    public BaseConfigFluent.AnnotationsNested<A> editMatchingAnnotation(io.dekorate.deps.kubernetes.api.builder.Predicate<AnnotationBuilder> predicate);
    public A withEnvVars(io.dekorate.kubernetes.config.Env... envVars);
    
/**
 * This method has been deprecated, please use method buildEnvVars instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Env[] getEnvVars();
    public io.dekorate.kubernetes.config.Env[] buildEnvVars();
    public io.dekorate.kubernetes.config.Env buildEnvVar(int index);
    public io.dekorate.kubernetes.config.Env buildFirstEnvVar();
    public io.dekorate.kubernetes.config.Env buildLastEnvVar();
    public io.dekorate.kubernetes.config.Env buildMatchingEnvVar(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public Boolean hasMatchingEnvVar(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public A addToEnvVars(int index,io.dekorate.kubernetes.config.Env item);
    public A setToEnvVars(int index,io.dekorate.kubernetes.config.Env item);
    public A addToEnvVars(io.dekorate.kubernetes.config.Env... items);
    public A addAllToEnvVars(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeFromEnvVars(io.dekorate.kubernetes.config.Env... items);
    public A removeAllFromEnvVars(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeMatchingFromEnvVars(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public Boolean hasEnvVars();
    public A addNewEnvVar(String name,String value,String secret,String configmap,String field);
    public BaseConfigFluent.EnvVarsNested<A> addNewEnvVar();
    public BaseConfigFluent.EnvVarsNested<A> addNewEnvVarLike(io.dekorate.kubernetes.config.Env item);
    public BaseConfigFluent.EnvVarsNested<A> setNewEnvVarLike(int index,io.dekorate.kubernetes.config.Env item);
    public BaseConfigFluent.EnvVarsNested<A> editEnvVar(int index);
    public BaseConfigFluent.EnvVarsNested<A> editFirstEnvVar();
    public BaseConfigFluent.EnvVarsNested<A> editLastEnvVar();
    public BaseConfigFluent.EnvVarsNested<A> editMatchingEnvVar(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public String getWorkingDir();
    public A withWorkingDir(String workingDir);
    public Boolean hasWorkingDir();
    public A withNewWorkingDir(String arg1);
    public A withNewWorkingDir(StringBuilder arg1);
    public A withNewWorkingDir(StringBuffer arg1);
    public A withCommand(String... command);
    public String[] getCommand();
    public A addToCommand(int index,String item);
    public A setToCommand(int index,String item);
    public A addToCommand(String... items);
    public A addAllToCommand(Collection<String> items);
    public A removeFromCommand(String... items);
    public A removeAllFromCommand(Collection<String> items);
    public Boolean hasCommand();
    public A addNewCommand(String arg1);
    public A addNewCommand(StringBuilder arg1);
    public A addNewCommand(StringBuffer arg1);
    public A withArguments(String... arguments);
    public String[] getArguments();
    public A addToArguments(int index,String item);
    public A setToArguments(int index,String item);
    public A addToArguments(String... items);
    public A addAllToArguments(Collection<String> items);
    public A removeFromArguments(String... items);
    public A removeAllFromArguments(Collection<String> items);
    public Boolean hasArguments();
    public A addNewArgument(String arg1);
    public A addNewArgument(StringBuilder arg1);
    public A addNewArgument(StringBuffer arg1);
    public int getReplicas();
    public A withReplicas(int replicas);
    public Boolean hasReplicas();
    public String getServiceAccount();
    public A withServiceAccount(String serviceAccount);
    public Boolean hasServiceAccount();
    public A withNewServiceAccount(String arg1);
    public A withNewServiceAccount(StringBuilder arg1);
    public A withNewServiceAccount(StringBuffer arg1);
    public String getHost();
    public A withHost(String host);
    public Boolean hasHost();
    public A withNewHost(String arg1);
    public A withNewHost(StringBuilder arg1);
    public A withNewHost(StringBuffer arg1);
    public A withPorts(io.dekorate.kubernetes.config.Port... ports);
    
/**
 * This method has been deprecated, please use method buildPorts instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Port[] getPorts();
    public io.dekorate.kubernetes.config.Port[] buildPorts();
    public io.dekorate.kubernetes.config.Port buildPort(int index);
    public io.dekorate.kubernetes.config.Port buildFirstPort();
    public io.dekorate.kubernetes.config.Port buildLastPort();
    public io.dekorate.kubernetes.config.Port buildMatchingPort(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate);
    public Boolean hasMatchingPort(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate);
    public A addToPorts(int index,io.dekorate.kubernetes.config.Port item);
    public A setToPorts(int index,io.dekorate.kubernetes.config.Port item);
    public A addToPorts(io.dekorate.kubernetes.config.Port... items);
    public A addAllToPorts(Collection<io.dekorate.kubernetes.config.Port> items);
    public A removeFromPorts(io.dekorate.kubernetes.config.Port... items);
    public A removeAllFromPorts(Collection<io.dekorate.kubernetes.config.Port> items);
    public A removeMatchingFromPorts(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate);
    public Boolean hasPorts();
    public BaseConfigFluent.PortsNested<A> addNewPort();
    public BaseConfigFluent.PortsNested<A> addNewPortLike(io.dekorate.kubernetes.config.Port item);
    public BaseConfigFluent.PortsNested<A> setNewPortLike(int index,io.dekorate.kubernetes.config.Port item);
    public BaseConfigFluent.PortsNested<A> editPort(int index);
    public BaseConfigFluent.PortsNested<A> editFirstPort();
    public BaseConfigFluent.PortsNested<A> editLastPort();
    public BaseConfigFluent.PortsNested<A> editMatchingPort(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate);
    public ServiceType getServiceType();
    public A withServiceType(ServiceType serviceType);
    public Boolean hasServiceType();
    public A withPvcVolumes(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume... pvcVolumes);
    
/**
 * This method has been deprecated, please use method buildPvcVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] getPvcVolumes();
    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] buildPvcVolumes();
    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume buildPvcVolume(int index);
    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume buildFirstPvcVolume();
    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume buildLastPvcVolume();
    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume buildMatchingPvcVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<PersistentVolumeClaimVolumeBuilder> predicate);
    public Boolean hasMatchingPvcVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<PersistentVolumeClaimVolumeBuilder> predicate);
    public A addToPvcVolumes(int index,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item);
    public A setToPvcVolumes(int index,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item);
    public A addToPvcVolumes(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume... items);
    public A addAllToPvcVolumes(Collection<io.dekorate.kubernetes.config.PersistentVolumeClaimVolume> items);
    public A removeFromPvcVolumes(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume... items);
    public A removeAllFromPvcVolumes(Collection<io.dekorate.kubernetes.config.PersistentVolumeClaimVolume> items);
    public A removeMatchingFromPvcVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<PersistentVolumeClaimVolumeBuilder> predicate);
    public Boolean hasPvcVolumes();
    public A addNewPvcVolume(String volumeName,String claimName,boolean readOnly);
    public BaseConfigFluent.PvcVolumesNested<A> addNewPvcVolume();
    public BaseConfigFluent.PvcVolumesNested<A> addNewPvcVolumeLike(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item);
    public BaseConfigFluent.PvcVolumesNested<A> setNewPvcVolumeLike(int index,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item);
    public BaseConfigFluent.PvcVolumesNested<A> editPvcVolume(int index);
    public BaseConfigFluent.PvcVolumesNested<A> editFirstPvcVolume();
    public BaseConfigFluent.PvcVolumesNested<A> editLastPvcVolume();
    public BaseConfigFluent.PvcVolumesNested<A> editMatchingPvcVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<PersistentVolumeClaimVolumeBuilder> predicate);
    public A withSecretVolumes(io.dekorate.kubernetes.config.SecretVolume... secretVolumes);
    
/**
 * This method has been deprecated, please use method buildSecretVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.SecretVolume[] getSecretVolumes();
    public io.dekorate.kubernetes.config.SecretVolume[] buildSecretVolumes();
    public io.dekorate.kubernetes.config.SecretVolume buildSecretVolume(int index);
    public io.dekorate.kubernetes.config.SecretVolume buildFirstSecretVolume();
    public io.dekorate.kubernetes.config.SecretVolume buildLastSecretVolume();
    public io.dekorate.kubernetes.config.SecretVolume buildMatchingSecretVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<SecretVolumeBuilder> predicate);
    public Boolean hasMatchingSecretVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<SecretVolumeBuilder> predicate);
    public A addToSecretVolumes(int index,io.dekorate.kubernetes.config.SecretVolume item);
    public A setToSecretVolumes(int index,io.dekorate.kubernetes.config.SecretVolume item);
    public A addToSecretVolumes(io.dekorate.kubernetes.config.SecretVolume... items);
    public A addAllToSecretVolumes(Collection<io.dekorate.kubernetes.config.SecretVolume> items);
    public A removeFromSecretVolumes(io.dekorate.kubernetes.config.SecretVolume... items);
    public A removeAllFromSecretVolumes(Collection<io.dekorate.kubernetes.config.SecretVolume> items);
    public A removeMatchingFromSecretVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<SecretVolumeBuilder> predicate);
    public Boolean hasSecretVolumes();
    public A addNewSecretVolume(String volumeName,String secretName,int defaultMode,boolean optional);
    public BaseConfigFluent.SecretVolumesNested<A> addNewSecretVolume();
    public BaseConfigFluent.SecretVolumesNested<A> addNewSecretVolumeLike(io.dekorate.kubernetes.config.SecretVolume item);
    public BaseConfigFluent.SecretVolumesNested<A> setNewSecretVolumeLike(int index,io.dekorate.kubernetes.config.SecretVolume item);
    public BaseConfigFluent.SecretVolumesNested<A> editSecretVolume(int index);
    public BaseConfigFluent.SecretVolumesNested<A> editFirstSecretVolume();
    public BaseConfigFluent.SecretVolumesNested<A> editLastSecretVolume();
    public BaseConfigFluent.SecretVolumesNested<A> editMatchingSecretVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<SecretVolumeBuilder> predicate);
    public A withConfigMapVolumes(io.dekorate.kubernetes.config.ConfigMapVolume... configMapVolumes);
    
/**
 * This method has been deprecated, please use method buildConfigMapVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.ConfigMapVolume[] getConfigMapVolumes();
    public io.dekorate.kubernetes.config.ConfigMapVolume[] buildConfigMapVolumes();
    public io.dekorate.kubernetes.config.ConfigMapVolume buildConfigMapVolume(int index);
    public io.dekorate.kubernetes.config.ConfigMapVolume buildFirstConfigMapVolume();
    public io.dekorate.kubernetes.config.ConfigMapVolume buildLastConfigMapVolume();
    public io.dekorate.kubernetes.config.ConfigMapVolume buildMatchingConfigMapVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<ConfigMapVolumeBuilder> predicate);
    public Boolean hasMatchingConfigMapVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<ConfigMapVolumeBuilder> predicate);
    public A addToConfigMapVolumes(int index,io.dekorate.kubernetes.config.ConfigMapVolume item);
    public A setToConfigMapVolumes(int index,io.dekorate.kubernetes.config.ConfigMapVolume item);
    public A addToConfigMapVolumes(io.dekorate.kubernetes.config.ConfigMapVolume... items);
    public A addAllToConfigMapVolumes(Collection<io.dekorate.kubernetes.config.ConfigMapVolume> items);
    public A removeFromConfigMapVolumes(io.dekorate.kubernetes.config.ConfigMapVolume... items);
    public A removeAllFromConfigMapVolumes(Collection<io.dekorate.kubernetes.config.ConfigMapVolume> items);
    public A removeMatchingFromConfigMapVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<ConfigMapVolumeBuilder> predicate);
    public Boolean hasConfigMapVolumes();
    public A addNewConfigMapVolume(String volumeName,String configMapName,int defaultMode,boolean optional);
    public BaseConfigFluent.ConfigMapVolumesNested<A> addNewConfigMapVolume();
    public BaseConfigFluent.ConfigMapVolumesNested<A> addNewConfigMapVolumeLike(io.dekorate.kubernetes.config.ConfigMapVolume item);
    public BaseConfigFluent.ConfigMapVolumesNested<A> setNewConfigMapVolumeLike(int index,io.dekorate.kubernetes.config.ConfigMapVolume item);
    public BaseConfigFluent.ConfigMapVolumesNested<A> editConfigMapVolume(int index);
    public BaseConfigFluent.ConfigMapVolumesNested<A> editFirstConfigMapVolume();
    public BaseConfigFluent.ConfigMapVolumesNested<A> editLastConfigMapVolume();
    public BaseConfigFluent.ConfigMapVolumesNested<A> editMatchingConfigMapVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<ConfigMapVolumeBuilder> predicate);
    public A withGitRepoVolumes(io.dekorate.kubernetes.config.GitRepoVolume... gitRepoVolumes);
    
/**
 * This method has been deprecated, please use method buildGitRepoVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.GitRepoVolume[] getGitRepoVolumes();
    public io.dekorate.kubernetes.config.GitRepoVolume[] buildGitRepoVolumes();
    public io.dekorate.kubernetes.config.GitRepoVolume buildGitRepoVolume(int index);
    public io.dekorate.kubernetes.config.GitRepoVolume buildFirstGitRepoVolume();
    public io.dekorate.kubernetes.config.GitRepoVolume buildLastGitRepoVolume();
    public io.dekorate.kubernetes.config.GitRepoVolume buildMatchingGitRepoVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<GitRepoVolumeBuilder> predicate);
    public Boolean hasMatchingGitRepoVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<GitRepoVolumeBuilder> predicate);
    public A addToGitRepoVolumes(int index,io.dekorate.kubernetes.config.GitRepoVolume item);
    public A setToGitRepoVolumes(int index,io.dekorate.kubernetes.config.GitRepoVolume item);
    public A addToGitRepoVolumes(io.dekorate.kubernetes.config.GitRepoVolume... items);
    public A addAllToGitRepoVolumes(Collection<io.dekorate.kubernetes.config.GitRepoVolume> items);
    public A removeFromGitRepoVolumes(io.dekorate.kubernetes.config.GitRepoVolume... items);
    public A removeAllFromGitRepoVolumes(Collection<io.dekorate.kubernetes.config.GitRepoVolume> items);
    public A removeMatchingFromGitRepoVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<GitRepoVolumeBuilder> predicate);
    public Boolean hasGitRepoVolumes();
    public A addNewGitRepoVolume(String volumeName,String repository,String directory,String revision);
    public BaseConfigFluent.GitRepoVolumesNested<A> addNewGitRepoVolume();
    public BaseConfigFluent.GitRepoVolumesNested<A> addNewGitRepoVolumeLike(io.dekorate.kubernetes.config.GitRepoVolume item);
    public BaseConfigFluent.GitRepoVolumesNested<A> setNewGitRepoVolumeLike(int index,io.dekorate.kubernetes.config.GitRepoVolume item);
    public BaseConfigFluent.GitRepoVolumesNested<A> editGitRepoVolume(int index);
    public BaseConfigFluent.GitRepoVolumesNested<A> editFirstGitRepoVolume();
    public BaseConfigFluent.GitRepoVolumesNested<A> editLastGitRepoVolume();
    public BaseConfigFluent.GitRepoVolumesNested<A> editMatchingGitRepoVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<GitRepoVolumeBuilder> predicate);
    public A withAwsElasticBlockStoreVolumes(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume... awsElasticBlockStoreVolumes);
    
/**
 * This method has been deprecated, please use method buildAwsElasticBlockStoreVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] getAwsElasticBlockStoreVolumes();
    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] buildAwsElasticBlockStoreVolumes();
    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume buildAwsElasticBlockStoreVolume(int index);
    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume buildFirstAwsElasticBlockStoreVolume();
    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume buildLastAwsElasticBlockStoreVolume();
    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume buildMatchingAwsElasticBlockStoreVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AwsElasticBlockStoreVolumeBuilder> predicate);
    public Boolean hasMatchingAwsElasticBlockStoreVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AwsElasticBlockStoreVolumeBuilder> predicate);
    public A addToAwsElasticBlockStoreVolumes(int index,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item);
    public A setToAwsElasticBlockStoreVolumes(int index,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item);
    public A addToAwsElasticBlockStoreVolumes(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume... items);
    public A addAllToAwsElasticBlockStoreVolumes(Collection<io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume> items);
    public A removeFromAwsElasticBlockStoreVolumes(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume... items);
    public A removeAllFromAwsElasticBlockStoreVolumes(Collection<io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume> items);
    public A removeMatchingFromAwsElasticBlockStoreVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<AwsElasticBlockStoreVolumeBuilder> predicate);
    public Boolean hasAwsElasticBlockStoreVolumes();
    public A addNewAwsElasticBlockStoreVolume(String volumeName,String volumeId,int partition,String fsType,boolean readOnly);
    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> addNewAwsElasticBlockStoreVolume();
    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> addNewAwsElasticBlockStoreVolumeLike(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item);
    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> setNewAwsElasticBlockStoreVolumeLike(int index,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item);
    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> editAwsElasticBlockStoreVolume(int index);
    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> editFirstAwsElasticBlockStoreVolume();
    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> editLastAwsElasticBlockStoreVolume();
    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> editMatchingAwsElasticBlockStoreVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AwsElasticBlockStoreVolumeBuilder> predicate);
    public A withAzureDiskVolumes(io.dekorate.kubernetes.config.AzureDiskVolume... azureDiskVolumes);
    
/**
 * This method has been deprecated, please use method buildAzureDiskVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.AzureDiskVolume[] getAzureDiskVolumes();
    public io.dekorate.kubernetes.config.AzureDiskVolume[] buildAzureDiskVolumes();
    public io.dekorate.kubernetes.config.AzureDiskVolume buildAzureDiskVolume(int index);
    public io.dekorate.kubernetes.config.AzureDiskVolume buildFirstAzureDiskVolume();
    public io.dekorate.kubernetes.config.AzureDiskVolume buildLastAzureDiskVolume();
    public io.dekorate.kubernetes.config.AzureDiskVolume buildMatchingAzureDiskVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureDiskVolumeBuilder> predicate);
    public Boolean hasMatchingAzureDiskVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureDiskVolumeBuilder> predicate);
    public A addToAzureDiskVolumes(int index,io.dekorate.kubernetes.config.AzureDiskVolume item);
    public A setToAzureDiskVolumes(int index,io.dekorate.kubernetes.config.AzureDiskVolume item);
    public A addToAzureDiskVolumes(io.dekorate.kubernetes.config.AzureDiskVolume... items);
    public A addAllToAzureDiskVolumes(Collection<io.dekorate.kubernetes.config.AzureDiskVolume> items);
    public A removeFromAzureDiskVolumes(io.dekorate.kubernetes.config.AzureDiskVolume... items);
    public A removeAllFromAzureDiskVolumes(Collection<io.dekorate.kubernetes.config.AzureDiskVolume> items);
    public A removeMatchingFromAzureDiskVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureDiskVolumeBuilder> predicate);
    public Boolean hasAzureDiskVolumes();
    public BaseConfigFluent.AzureDiskVolumesNested<A> addNewAzureDiskVolume();
    public BaseConfigFluent.AzureDiskVolumesNested<A> addNewAzureDiskVolumeLike(io.dekorate.kubernetes.config.AzureDiskVolume item);
    public BaseConfigFluent.AzureDiskVolumesNested<A> setNewAzureDiskVolumeLike(int index,io.dekorate.kubernetes.config.AzureDiskVolume item);
    public BaseConfigFluent.AzureDiskVolumesNested<A> editAzureDiskVolume(int index);
    public BaseConfigFluent.AzureDiskVolumesNested<A> editFirstAzureDiskVolume();
    public BaseConfigFluent.AzureDiskVolumesNested<A> editLastAzureDiskVolume();
    public BaseConfigFluent.AzureDiskVolumesNested<A> editMatchingAzureDiskVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureDiskVolumeBuilder> predicate);
    public A withAzureFileVolumes(io.dekorate.kubernetes.config.AzureFileVolume... azureFileVolumes);
    
/**
 * This method has been deprecated, please use method buildAzureFileVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.AzureFileVolume[] getAzureFileVolumes();
    public io.dekorate.kubernetes.config.AzureFileVolume[] buildAzureFileVolumes();
    public io.dekorate.kubernetes.config.AzureFileVolume buildAzureFileVolume(int index);
    public io.dekorate.kubernetes.config.AzureFileVolume buildFirstAzureFileVolume();
    public io.dekorate.kubernetes.config.AzureFileVolume buildLastAzureFileVolume();
    public io.dekorate.kubernetes.config.AzureFileVolume buildMatchingAzureFileVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureFileVolumeBuilder> predicate);
    public Boolean hasMatchingAzureFileVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureFileVolumeBuilder> predicate);
    public A addToAzureFileVolumes(int index,io.dekorate.kubernetes.config.AzureFileVolume item);
    public A setToAzureFileVolumes(int index,io.dekorate.kubernetes.config.AzureFileVolume item);
    public A addToAzureFileVolumes(io.dekorate.kubernetes.config.AzureFileVolume... items);
    public A addAllToAzureFileVolumes(Collection<io.dekorate.kubernetes.config.AzureFileVolume> items);
    public A removeFromAzureFileVolumes(io.dekorate.kubernetes.config.AzureFileVolume... items);
    public A removeAllFromAzureFileVolumes(Collection<io.dekorate.kubernetes.config.AzureFileVolume> items);
    public A removeMatchingFromAzureFileVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureFileVolumeBuilder> predicate);
    public Boolean hasAzureFileVolumes();
    public A addNewAzureFileVolume(String volumeName,String shareName,String secretName,boolean readOnly);
    public BaseConfigFluent.AzureFileVolumesNested<A> addNewAzureFileVolume();
    public BaseConfigFluent.AzureFileVolumesNested<A> addNewAzureFileVolumeLike(io.dekorate.kubernetes.config.AzureFileVolume item);
    public BaseConfigFluent.AzureFileVolumesNested<A> setNewAzureFileVolumeLike(int index,io.dekorate.kubernetes.config.AzureFileVolume item);
    public BaseConfigFluent.AzureFileVolumesNested<A> editAzureFileVolume(int index);
    public BaseConfigFluent.AzureFileVolumesNested<A> editFirstAzureFileVolume();
    public BaseConfigFluent.AzureFileVolumesNested<A> editLastAzureFileVolume();
    public BaseConfigFluent.AzureFileVolumesNested<A> editMatchingAzureFileVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureFileVolumeBuilder> predicate);
    public A withMounts(io.dekorate.kubernetes.config.Mount... mounts);
    
/**
 * This method has been deprecated, please use method buildMounts instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Mount[] getMounts();
    public io.dekorate.kubernetes.config.Mount[] buildMounts();
    public io.dekorate.kubernetes.config.Mount buildMount(int index);
    public io.dekorate.kubernetes.config.Mount buildFirstMount();
    public io.dekorate.kubernetes.config.Mount buildLastMount();
    public io.dekorate.kubernetes.config.Mount buildMatchingMount(io.dekorate.deps.kubernetes.api.builder.Predicate<MountBuilder> predicate);
    public Boolean hasMatchingMount(io.dekorate.deps.kubernetes.api.builder.Predicate<MountBuilder> predicate);
    public A addToMounts(int index,io.dekorate.kubernetes.config.Mount item);
    public A setToMounts(int index,io.dekorate.kubernetes.config.Mount item);
    public A addToMounts(io.dekorate.kubernetes.config.Mount... items);
    public A addAllToMounts(Collection<io.dekorate.kubernetes.config.Mount> items);
    public A removeFromMounts(io.dekorate.kubernetes.config.Mount... items);
    public A removeAllFromMounts(Collection<io.dekorate.kubernetes.config.Mount> items);
    public A removeMatchingFromMounts(io.dekorate.deps.kubernetes.api.builder.Predicate<MountBuilder> predicate);
    public Boolean hasMounts();
    public A addNewMount(String name,String path,String subPath,boolean readOnly);
    public BaseConfigFluent.MountsNested<A> addNewMount();
    public BaseConfigFluent.MountsNested<A> addNewMountLike(io.dekorate.kubernetes.config.Mount item);
    public BaseConfigFluent.MountsNested<A> setNewMountLike(int index,io.dekorate.kubernetes.config.Mount item);
    public BaseConfigFluent.MountsNested<A> editMount(int index);
    public BaseConfigFluent.MountsNested<A> editFirstMount();
    public BaseConfigFluent.MountsNested<A> editLastMount();
    public BaseConfigFluent.MountsNested<A> editMatchingMount(io.dekorate.deps.kubernetes.api.builder.Predicate<MountBuilder> predicate);
    public ImagePullPolicy getImagePullPolicy();
    public A withImagePullPolicy(ImagePullPolicy imagePullPolicy);
    public Boolean hasImagePullPolicy();
    public A withImagePullSecrets(String... imagePullSecrets);
    public String[] getImagePullSecrets();
    public A addToImagePullSecrets(int index,String item);
    public A setToImagePullSecrets(int index,String item);
    public A addToImagePullSecrets(String... items);
    public A addAllToImagePullSecrets(Collection<String> items);
    public A removeFromImagePullSecrets(String... items);
    public A removeAllFromImagePullSecrets(Collection<String> items);
    public Boolean hasImagePullSecrets();
    public A addNewImagePullSecret(String arg1);
    public A addNewImagePullSecret(StringBuilder arg1);
    public A addNewImagePullSecret(StringBuffer arg1);
    
/**
 * This method has been deprecated, please use method buildLivenessProbe instead.
 * @return The buildable object.
 */
@Deprecated public io.dekorate.kubernetes.config.Probe getLivenessProbe();
    public io.dekorate.kubernetes.config.Probe buildLivenessProbe();
    public A withLivenessProbe(io.dekorate.kubernetes.config.Probe livenessProbe);
    public Boolean hasLivenessProbe();
    public BaseConfigFluent.LivenessProbeNested<A> withNewLivenessProbe();
    public BaseConfigFluent.LivenessProbeNested<A> withNewLivenessProbeLike(io.dekorate.kubernetes.config.Probe item);
    public BaseConfigFluent.LivenessProbeNested<A> editLivenessProbe();
    public BaseConfigFluent.LivenessProbeNested<A> editOrNewLivenessProbe();
    public BaseConfigFluent.LivenessProbeNested<A> editOrNewLivenessProbeLike(io.dekorate.kubernetes.config.Probe item);
    
/**
 * This method has been deprecated, please use method buildReadinessProbe instead.
 * @return The buildable object.
 */
@Deprecated public io.dekorate.kubernetes.config.Probe getReadinessProbe();
    public io.dekorate.kubernetes.config.Probe buildReadinessProbe();
    public A withReadinessProbe(io.dekorate.kubernetes.config.Probe readinessProbe);
    public Boolean hasReadinessProbe();
    public BaseConfigFluent.ReadinessProbeNested<A> withNewReadinessProbe();
    public BaseConfigFluent.ReadinessProbeNested<A> withNewReadinessProbeLike(io.dekorate.kubernetes.config.Probe item);
    public BaseConfigFluent.ReadinessProbeNested<A> editReadinessProbe();
    public BaseConfigFluent.ReadinessProbeNested<A> editOrNewReadinessProbe();
    public BaseConfigFluent.ReadinessProbeNested<A> editOrNewReadinessProbeLike(io.dekorate.kubernetes.config.Probe item);
    public A withSidecars(io.dekorate.kubernetes.config.Container... sidecars);
    
/**
 * This method has been deprecated, please use method buildSidecars instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Container[] getSidecars();
    public io.dekorate.kubernetes.config.Container[] buildSidecars();
    public io.dekorate.kubernetes.config.Container buildSidecar(int index);
    public io.dekorate.kubernetes.config.Container buildFirstSidecar();
    public io.dekorate.kubernetes.config.Container buildLastSidecar();
    public io.dekorate.kubernetes.config.Container buildMatchingSidecar(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public Boolean hasMatchingSidecar(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public A addToSidecars(int index,io.dekorate.kubernetes.config.Container item);
    public A setToSidecars(int index,io.dekorate.kubernetes.config.Container item);
    public A addToSidecars(io.dekorate.kubernetes.config.Container... items);
    public A addAllToSidecars(Collection<io.dekorate.kubernetes.config.Container> items);
    public A removeFromSidecars(io.dekorate.kubernetes.config.Container... items);
    public A removeAllFromSidecars(Collection<io.dekorate.kubernetes.config.Container> items);
    public A removeMatchingFromSidecars(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public Boolean hasSidecars();
    public BaseConfigFluent.SidecarsNested<A> addNewSidecar();
    public BaseConfigFluent.SidecarsNested<A> addNewSidecarLike(io.dekorate.kubernetes.config.Container item);
    public BaseConfigFluent.SidecarsNested<A> setNewSidecarLike(int index,io.dekorate.kubernetes.config.Container item);
    public BaseConfigFluent.SidecarsNested<A> editSidecar(int index);
    public BaseConfigFluent.SidecarsNested<A> editFirstSidecar();
    public BaseConfigFluent.SidecarsNested<A> editLastSidecar();
    public BaseConfigFluent.SidecarsNested<A> editMatchingSidecar(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public boolean isExpose();
    public A withExpose(boolean expose);
    public Boolean hasExpose();
    public boolean isAutoDeployEnabled();
    public A withAutoDeployEnabled(boolean autoDeployEnabled);
    public Boolean hasAutoDeployEnabled();

    public interface InitContainersNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ContainerFluent<BaseConfigFluent.InitContainersNested<N>>{

        
    public N and();    public N endInitContainer();
}
    public interface LabelsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,LabelFluent<BaseConfigFluent.LabelsNested<N>>{

        
    public N and();    public N endLabel();
}
    public interface AnnotationsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,AnnotationFluent<BaseConfigFluent.AnnotationsNested<N>>{

        
    public N and();    public N endAnnotation();
}
    public interface EnvVarsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,EnvFluent<BaseConfigFluent.EnvVarsNested<N>>{

        
    public N and();    public N endEnvVar();
}
    public interface PortsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,PortFluent<BaseConfigFluent.PortsNested<N>>{

        
    public N and();    public N endPort();
}
    public interface PvcVolumesNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,PersistentVolumeClaimVolumeFluent<BaseConfigFluent.PvcVolumesNested<N>>{

        
    public N and();    public N endPvcVolume();
}
    public interface SecretVolumesNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,SecretVolumeFluent<BaseConfigFluent.SecretVolumesNested<N>>{

        
    public N and();    public N endSecretVolume();
}
    public interface ConfigMapVolumesNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ConfigMapVolumeFluent<BaseConfigFluent.ConfigMapVolumesNested<N>>{

        
    public N and();    public N endConfigMapVolume();
}
    public interface GitRepoVolumesNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,GitRepoVolumeFluent<BaseConfigFluent.GitRepoVolumesNested<N>>{

        
    public N and();    public N endGitRepoVolume();
}
    public interface AwsElasticBlockStoreVolumesNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,AwsElasticBlockStoreVolumeFluent<BaseConfigFluent.AwsElasticBlockStoreVolumesNested<N>>{

        
    public N and();    public N endAwsElasticBlockStoreVolume();
}
    public interface AzureDiskVolumesNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,AzureDiskVolumeFluent<BaseConfigFluent.AzureDiskVolumesNested<N>>{

        
    public N and();    public N endAzureDiskVolume();
}
    public interface AzureFileVolumesNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,AzureFileVolumeFluent<BaseConfigFluent.AzureFileVolumesNested<N>>{

        
    public N and();    public N endAzureFileVolume();
}
    public interface MountsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,MountFluent<BaseConfigFluent.MountsNested<N>>{

        
    public N and();    public N endMount();
}
    public interface LivenessProbeNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ProbeFluent<BaseConfigFluent.LivenessProbeNested<N>>{

        
    public N and();    public N endLivenessProbe();
}
    public interface ReadinessProbeNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ProbeFluent<BaseConfigFluent.ReadinessProbeNested<N>>{

        
    public N and();    public N endReadinessProbe();
}
    public interface SidecarsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ContainerFluent<BaseConfigFluent.SidecarsNested<N>>{

        
    public N and();    public N endSidecar();
}


}
