package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import io.dekorate.kubernetes.annotation.ServiceType;
import java.util.List;
import java.lang.Boolean;
import java.util.Collection;
import java.lang.Object;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.lang.Deprecated;
import java.util.Iterator;
import java.lang.StringBuffer;
import io.dekorate.kubernetes.annotation.ImagePullPolicy;

public class BaseConfigFluentImpl<A extends BaseConfigFluent<A>> extends ApplicationConfigurationFluentImpl<A> implements BaseConfigFluent<A>{

    private List<ContainerBuilder> initContainers =  new ArrayList<ContainerBuilder>();
    private List<LabelBuilder> labels =  new ArrayList<LabelBuilder>();
    private List<AnnotationBuilder> annotations =  new ArrayList<AnnotationBuilder>();
    private List<EnvBuilder> envVars =  new ArrayList<EnvBuilder>();
    private String workingDir = "";
    private List<String> command = new ArrayList<String>();
    private List<String> arguments = new ArrayList<String>();
    private int replicas = 1;
    private String serviceAccount = "";
    private String host = "";
    private List<PortBuilder> ports =  new ArrayList<PortBuilder>();
    private ServiceType serviceType = io.dekorate.kubernetes.annotation.ServiceType.ClusterIP;
    private List<PersistentVolumeClaimVolumeBuilder> pvcVolumes =  new ArrayList<PersistentVolumeClaimVolumeBuilder>();
    private List<SecretVolumeBuilder> secretVolumes =  new ArrayList<SecretVolumeBuilder>();
    private List<ConfigMapVolumeBuilder> configMapVolumes =  new ArrayList<ConfigMapVolumeBuilder>();
    private List<GitRepoVolumeBuilder> gitRepoVolumes =  new ArrayList<GitRepoVolumeBuilder>();
    private List<AwsElasticBlockStoreVolumeBuilder> awsElasticBlockStoreVolumes =  new ArrayList<AwsElasticBlockStoreVolumeBuilder>();
    private List<AzureDiskVolumeBuilder> azureDiskVolumes =  new ArrayList<AzureDiskVolumeBuilder>();
    private List<AzureFileVolumeBuilder> azureFileVolumes =  new ArrayList<AzureFileVolumeBuilder>();
    private List<MountBuilder> mounts =  new ArrayList<MountBuilder>();
    private ImagePullPolicy imagePullPolicy = io.dekorate.kubernetes.annotation.ImagePullPolicy.IfNotPresent;
    private List<String> imagePullSecrets = new ArrayList<String>();
    private ProbeBuilder livenessProbe = new ProbeBuilder();
    private ProbeBuilder readinessProbe = new ProbeBuilder();
    private List<ContainerBuilder> sidecars =  new ArrayList<ContainerBuilder>();
    private boolean expose = false;
    private boolean autoDeployEnabled = false;

    public BaseConfigFluentImpl(){
    }
    public BaseConfigFluentImpl(BaseConfig instance){
            this.withProject(instance.getProject()); 
            this.withAttributes(instance.getAttributes()); 
            this.withGroup(instance.getGroup()); 
            this.withName(instance.getName()); 
            this.withVersion(instance.getVersion()); 
            this.withInitContainers(instance.getInitContainers()); 
            this.withLabels(instance.getLabels()); 
            this.withAnnotations(instance.getAnnotations()); 
            this.withEnvVars(instance.getEnvVars()); 
            this.withWorkingDir(instance.getWorkingDir()); 
            this.withCommand(instance.getCommand()); 
            this.withArguments(instance.getArguments()); 
            this.withReplicas(instance.getReplicas()); 
            this.withServiceAccount(instance.getServiceAccount()); 
            this.withHost(instance.getHost()); 
            this.withPorts(instance.getPorts()); 
            this.withServiceType(instance.getServiceType()); 
            this.withPvcVolumes(instance.getPvcVolumes()); 
            this.withSecretVolumes(instance.getSecretVolumes()); 
            this.withConfigMapVolumes(instance.getConfigMapVolumes()); 
            this.withGitRepoVolumes(instance.getGitRepoVolumes()); 
            this.withAwsElasticBlockStoreVolumes(instance.getAwsElasticBlockStoreVolumes()); 
            this.withAzureDiskVolumes(instance.getAzureDiskVolumes()); 
            this.withAzureFileVolumes(instance.getAzureFileVolumes()); 
            this.withMounts(instance.getMounts()); 
            this.withImagePullPolicy(instance.getImagePullPolicy()); 
            this.withImagePullSecrets(instance.getImagePullSecrets()); 
            this.withLivenessProbe(instance.getLivenessProbe()); 
            this.withReadinessProbe(instance.getReadinessProbe()); 
            this.withSidecars(instance.getSidecars()); 
            this.withExpose(instance.isExpose()); 
            this.withAutoDeployEnabled(instance.isAutoDeployEnabled()); 
    }

    public A withInitContainers(io.dekorate.kubernetes.config.Container... initContainers){
            if (this.initContainers != null) {this.initContainers.clear();}
            if (initContainers != null) {for (io.dekorate.kubernetes.config.Container item :initContainers){ this.addToInitContainers(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildInitContainers instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Container[] getInitContainers(){
            int size = initContainers != null ? initContainers.size() : 0;
io.dekorate.kubernetes.config.Container[] result = new io.dekorate.kubernetes.config.Container[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Container,?> builder : initContainers) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Container[] buildInitContainers(){
            int size = initContainers != null ? initContainers.size() : 0;
io.dekorate.kubernetes.config.Container[] result = new io.dekorate.kubernetes.config.Container[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Container,?> builder : initContainers) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Container buildInitContainer(int index){
            return this.initContainers.get(index).build();
    }

    public io.dekorate.kubernetes.config.Container buildFirstInitContainer(){
            return this.initContainers.get(0).build();
    }

    public io.dekorate.kubernetes.config.Container buildLastInitContainer(){
            return this.initContainers.get(initContainers.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.Container buildMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate){
            for (ContainerBuilder item: initContainers) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate){
            for (ContainerBuilder item: initContainers) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToInitContainers(int index,io.dekorate.kubernetes.config.Container item){
            if (this.initContainers == null) {this.initContainers = new ArrayList<ContainerBuilder>();}
            io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);_visitables.get("initContainers").add(index >= 0 ? index : _visitables.get("initContainers").size(), builder);this.initContainers.add(index >= 0 ? index : initContainers.size(), builder); return (A)this;
    }

    public A setToInitContainers(int index,io.dekorate.kubernetes.config.Container item){
            if (this.initContainers == null) {this.initContainers = new ArrayList<ContainerBuilder>();}
            io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);
            if (index < 0 || index >= _visitables.get("initContainers").size()) { _visitables.get("initContainers").add(builder); } else { _visitables.get("initContainers").set(index, builder);}
            if (index < 0 || index >= initContainers.size()) { initContainers.add(builder); } else { initContainers.set(index, builder);}
             return (A)this;
    }

    public A addToInitContainers(io.dekorate.kubernetes.config.Container... items){
            if (this.initContainers == null) {this.initContainers = new ArrayList<ContainerBuilder>();}
            for (io.dekorate.kubernetes.config.Container item : items) {io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);_visitables.get("initContainers").add(builder);this.initContainers.add(builder);} return (A)this;
    }

    public A addAllToInitContainers(Collection<io.dekorate.kubernetes.config.Container> items){
            if (this.initContainers == null) {this.initContainers = new ArrayList<ContainerBuilder>();}
            for (io.dekorate.kubernetes.config.Container item : items) {io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);_visitables.get("initContainers").add(builder);this.initContainers.add(builder);} return (A)this;
    }

    public A removeFromInitContainers(io.dekorate.kubernetes.config.Container... items){
            for (io.dekorate.kubernetes.config.Container item : items) {io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);_visitables.get("initContainers").remove(builder);if (this.initContainers != null) {this.initContainers.remove(builder);}} return (A)this;
    }

    public A removeAllFromInitContainers(Collection<io.dekorate.kubernetes.config.Container> items){
            for (io.dekorate.kubernetes.config.Container item : items) {io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);_visitables.get("initContainers").remove(builder);if (this.initContainers != null) {this.initContainers.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromInitContainers(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate){
            if (initContainers == null) return (A) this;
            final Iterator<ContainerBuilder> each = initContainers.iterator();
            final List visitables = _visitables.get("initContainers");
            while (each.hasNext()) {
              ContainerBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasInitContainers(){
            return initContainers != null && !initContainers.isEmpty();
    }

    public BaseConfigFluent.InitContainersNested<A> addNewInitContainer(){
            return new InitContainersNestedImpl();
    }

    public BaseConfigFluent.InitContainersNested<A> addNewInitContainerLike(io.dekorate.kubernetes.config.Container item){
            return new InitContainersNestedImpl(-1, item);
    }

    public BaseConfigFluent.InitContainersNested<A> setNewInitContainerLike(int index,io.dekorate.kubernetes.config.Container item){
            return new InitContainersNestedImpl(index, item);
    }

    public BaseConfigFluent.InitContainersNested<A> editInitContainer(int index){
            if (initContainers.size() <= index) throw new RuntimeException("Can't edit initContainers. Index exceeds size.");
            return setNewInitContainerLike(index, buildInitContainer(index));
    }

    public BaseConfigFluent.InitContainersNested<A> editFirstInitContainer(){
            if (initContainers.size() == 0) throw new RuntimeException("Can't edit first initContainers. The list is empty.");
            return setNewInitContainerLike(0, buildInitContainer(0));
    }

    public BaseConfigFluent.InitContainersNested<A> editLastInitContainer(){
            int index = initContainers.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last initContainers. The list is empty.");
            return setNewInitContainerLike(index, buildInitContainer(index));
    }

    public BaseConfigFluent.InitContainersNested<A> editMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate){
            int index = -1;
            for (int i=0;i<initContainers.size();i++) { 
            if (predicate.apply(initContainers.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching initContainers. No match found.");
            return setNewInitContainerLike(index, buildInitContainer(index));
    }

    public A withLabels(io.dekorate.kubernetes.config.Label... labels){
            if (this.labels != null) {this.labels.clear();}
            if (labels != null) {for (io.dekorate.kubernetes.config.Label item :labels){ this.addToLabels(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildLabels instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Label[] getLabels(){
            int size = labels != null ? labels.size() : 0;
io.dekorate.kubernetes.config.Label[] result = new io.dekorate.kubernetes.config.Label[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Label,?> builder : labels) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Label[] buildLabels(){
            int size = labels != null ? labels.size() : 0;
io.dekorate.kubernetes.config.Label[] result = new io.dekorate.kubernetes.config.Label[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Label,?> builder : labels) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Label buildLabel(int index){
            return this.labels.get(index).build();
    }

    public io.dekorate.kubernetes.config.Label buildFirstLabel(){
            return this.labels.get(0).build();
    }

    public io.dekorate.kubernetes.config.Label buildLastLabel(){
            return this.labels.get(labels.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.Label buildMatchingLabel(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate){
            for (LabelBuilder item: labels) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingLabel(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate){
            for (LabelBuilder item: labels) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToLabels(int index,io.dekorate.kubernetes.config.Label item){
            if (this.labels == null) {this.labels = new ArrayList<LabelBuilder>();}
            io.dekorate.kubernetes.config.LabelBuilder builder = new io.dekorate.kubernetes.config.LabelBuilder(item);_visitables.get("labels").add(index >= 0 ? index : _visitables.get("labels").size(), builder);this.labels.add(index >= 0 ? index : labels.size(), builder); return (A)this;
    }

    public A setToLabels(int index,io.dekorate.kubernetes.config.Label item){
            if (this.labels == null) {this.labels = new ArrayList<LabelBuilder>();}
            io.dekorate.kubernetes.config.LabelBuilder builder = new io.dekorate.kubernetes.config.LabelBuilder(item);
            if (index < 0 || index >= _visitables.get("labels").size()) { _visitables.get("labels").add(builder); } else { _visitables.get("labels").set(index, builder);}
            if (index < 0 || index >= labels.size()) { labels.add(builder); } else { labels.set(index, builder);}
             return (A)this;
    }

    public A addToLabels(io.dekorate.kubernetes.config.Label... items){
            if (this.labels == null) {this.labels = new ArrayList<LabelBuilder>();}
            for (io.dekorate.kubernetes.config.Label item : items) {io.dekorate.kubernetes.config.LabelBuilder builder = new io.dekorate.kubernetes.config.LabelBuilder(item);_visitables.get("labels").add(builder);this.labels.add(builder);} return (A)this;
    }

    public A addAllToLabels(Collection<io.dekorate.kubernetes.config.Label> items){
            if (this.labels == null) {this.labels = new ArrayList<LabelBuilder>();}
            for (io.dekorate.kubernetes.config.Label item : items) {io.dekorate.kubernetes.config.LabelBuilder builder = new io.dekorate.kubernetes.config.LabelBuilder(item);_visitables.get("labels").add(builder);this.labels.add(builder);} return (A)this;
    }

    public A removeFromLabels(io.dekorate.kubernetes.config.Label... items){
            for (io.dekorate.kubernetes.config.Label item : items) {io.dekorate.kubernetes.config.LabelBuilder builder = new io.dekorate.kubernetes.config.LabelBuilder(item);_visitables.get("labels").remove(builder);if (this.labels != null) {this.labels.remove(builder);}} return (A)this;
    }

    public A removeAllFromLabels(Collection<io.dekorate.kubernetes.config.Label> items){
            for (io.dekorate.kubernetes.config.Label item : items) {io.dekorate.kubernetes.config.LabelBuilder builder = new io.dekorate.kubernetes.config.LabelBuilder(item);_visitables.get("labels").remove(builder);if (this.labels != null) {this.labels.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromLabels(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate){
            if (labels == null) return (A) this;
            final Iterator<LabelBuilder> each = labels.iterator();
            final List visitables = _visitables.get("labels");
            while (each.hasNext()) {
              LabelBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasLabels(){
            return labels != null && !labels.isEmpty();
    }

    public A addNewLabel(String key,String value){
            return (A)addToLabels(new Label(key, value));
    }

    public BaseConfigFluent.LabelsNested<A> addNewLabel(){
            return new LabelsNestedImpl();
    }

    public BaseConfigFluent.LabelsNested<A> addNewLabelLike(io.dekorate.kubernetes.config.Label item){
            return new LabelsNestedImpl(-1, item);
    }

    public BaseConfigFluent.LabelsNested<A> setNewLabelLike(int index,io.dekorate.kubernetes.config.Label item){
            return new LabelsNestedImpl(index, item);
    }

    public BaseConfigFluent.LabelsNested<A> editLabel(int index){
            if (labels.size() <= index) throw new RuntimeException("Can't edit labels. Index exceeds size.");
            return setNewLabelLike(index, buildLabel(index));
    }

    public BaseConfigFluent.LabelsNested<A> editFirstLabel(){
            if (labels.size() == 0) throw new RuntimeException("Can't edit first labels. The list is empty.");
            return setNewLabelLike(0, buildLabel(0));
    }

    public BaseConfigFluent.LabelsNested<A> editLastLabel(){
            int index = labels.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last labels. The list is empty.");
            return setNewLabelLike(index, buildLabel(index));
    }

    public BaseConfigFluent.LabelsNested<A> editMatchingLabel(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate){
            int index = -1;
            for (int i=0;i<labels.size();i++) { 
            if (predicate.apply(labels.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching labels. No match found.");
            return setNewLabelLike(index, buildLabel(index));
    }

    public A withAnnotations(io.dekorate.kubernetes.config.Annotation... annotations){
            if (this.annotations != null) {this.annotations.clear();}
            if (annotations != null) {for (io.dekorate.kubernetes.config.Annotation item :annotations){ this.addToAnnotations(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildAnnotations instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Annotation[] getAnnotations(){
            int size = annotations != null ? annotations.size() : 0;
io.dekorate.kubernetes.config.Annotation[] result = new io.dekorate.kubernetes.config.Annotation[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Annotation,?> builder : annotations) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Annotation[] buildAnnotations(){
            int size = annotations != null ? annotations.size() : 0;
io.dekorate.kubernetes.config.Annotation[] result = new io.dekorate.kubernetes.config.Annotation[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Annotation,?> builder : annotations) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Annotation buildAnnotation(int index){
            return this.annotations.get(index).build();
    }

    public io.dekorate.kubernetes.config.Annotation buildFirstAnnotation(){
            return this.annotations.get(0).build();
    }

    public io.dekorate.kubernetes.config.Annotation buildLastAnnotation(){
            return this.annotations.get(annotations.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.Annotation buildMatchingAnnotation(io.dekorate.deps.kubernetes.api.builder.Predicate<AnnotationBuilder> predicate){
            for (AnnotationBuilder item: annotations) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingAnnotation(io.dekorate.deps.kubernetes.api.builder.Predicate<AnnotationBuilder> predicate){
            for (AnnotationBuilder item: annotations) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToAnnotations(int index,io.dekorate.kubernetes.config.Annotation item){
            if (this.annotations == null) {this.annotations = new ArrayList<AnnotationBuilder>();}
            io.dekorate.kubernetes.config.AnnotationBuilder builder = new io.dekorate.kubernetes.config.AnnotationBuilder(item);_visitables.get("annotations").add(index >= 0 ? index : _visitables.get("annotations").size(), builder);this.annotations.add(index >= 0 ? index : annotations.size(), builder); return (A)this;
    }

    public A setToAnnotations(int index,io.dekorate.kubernetes.config.Annotation item){
            if (this.annotations == null) {this.annotations = new ArrayList<AnnotationBuilder>();}
            io.dekorate.kubernetes.config.AnnotationBuilder builder = new io.dekorate.kubernetes.config.AnnotationBuilder(item);
            if (index < 0 || index >= _visitables.get("annotations").size()) { _visitables.get("annotations").add(builder); } else { _visitables.get("annotations").set(index, builder);}
            if (index < 0 || index >= annotations.size()) { annotations.add(builder); } else { annotations.set(index, builder);}
             return (A)this;
    }

    public A addToAnnotations(io.dekorate.kubernetes.config.Annotation... items){
            if (this.annotations == null) {this.annotations = new ArrayList<AnnotationBuilder>();}
            for (io.dekorate.kubernetes.config.Annotation item : items) {io.dekorate.kubernetes.config.AnnotationBuilder builder = new io.dekorate.kubernetes.config.AnnotationBuilder(item);_visitables.get("annotations").add(builder);this.annotations.add(builder);} return (A)this;
    }

    public A addAllToAnnotations(Collection<io.dekorate.kubernetes.config.Annotation> items){
            if (this.annotations == null) {this.annotations = new ArrayList<AnnotationBuilder>();}
            for (io.dekorate.kubernetes.config.Annotation item : items) {io.dekorate.kubernetes.config.AnnotationBuilder builder = new io.dekorate.kubernetes.config.AnnotationBuilder(item);_visitables.get("annotations").add(builder);this.annotations.add(builder);} return (A)this;
    }

    public A removeFromAnnotations(io.dekorate.kubernetes.config.Annotation... items){
            for (io.dekorate.kubernetes.config.Annotation item : items) {io.dekorate.kubernetes.config.AnnotationBuilder builder = new io.dekorate.kubernetes.config.AnnotationBuilder(item);_visitables.get("annotations").remove(builder);if (this.annotations != null) {this.annotations.remove(builder);}} return (A)this;
    }

    public A removeAllFromAnnotations(Collection<io.dekorate.kubernetes.config.Annotation> items){
            for (io.dekorate.kubernetes.config.Annotation item : items) {io.dekorate.kubernetes.config.AnnotationBuilder builder = new io.dekorate.kubernetes.config.AnnotationBuilder(item);_visitables.get("annotations").remove(builder);if (this.annotations != null) {this.annotations.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromAnnotations(io.dekorate.deps.kubernetes.api.builder.Predicate<AnnotationBuilder> predicate){
            if (annotations == null) return (A) this;
            final Iterator<AnnotationBuilder> each = annotations.iterator();
            final List visitables = _visitables.get("annotations");
            while (each.hasNext()) {
              AnnotationBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasAnnotations(){
            return annotations != null && !annotations.isEmpty();
    }

    public A addNewAnnotation(String key,String value){
            return (A)addToAnnotations(new Annotation(key, value));
    }

    public BaseConfigFluent.AnnotationsNested<A> addNewAnnotation(){
            return new AnnotationsNestedImpl();
    }

    public BaseConfigFluent.AnnotationsNested<A> addNewAnnotationLike(io.dekorate.kubernetes.config.Annotation item){
            return new AnnotationsNestedImpl(-1, item);
    }

    public BaseConfigFluent.AnnotationsNested<A> setNewAnnotationLike(int index,io.dekorate.kubernetes.config.Annotation item){
            return new AnnotationsNestedImpl(index, item);
    }

    public BaseConfigFluent.AnnotationsNested<A> editAnnotation(int index){
            if (annotations.size() <= index) throw new RuntimeException("Can't edit annotations. Index exceeds size.");
            return setNewAnnotationLike(index, buildAnnotation(index));
    }

    public BaseConfigFluent.AnnotationsNested<A> editFirstAnnotation(){
            if (annotations.size() == 0) throw new RuntimeException("Can't edit first annotations. The list is empty.");
            return setNewAnnotationLike(0, buildAnnotation(0));
    }

    public BaseConfigFluent.AnnotationsNested<A> editLastAnnotation(){
            int index = annotations.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last annotations. The list is empty.");
            return setNewAnnotationLike(index, buildAnnotation(index));
    }

    public BaseConfigFluent.AnnotationsNested<A> editMatchingAnnotation(io.dekorate.deps.kubernetes.api.builder.Predicate<AnnotationBuilder> predicate){
            int index = -1;
            for (int i=0;i<annotations.size();i++) { 
            if (predicate.apply(annotations.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching annotations. No match found.");
            return setNewAnnotationLike(index, buildAnnotation(index));
    }

    public A withEnvVars(io.dekorate.kubernetes.config.Env... envVars){
            if (this.envVars != null) {this.envVars.clear();}
            if (envVars != null) {for (io.dekorate.kubernetes.config.Env item :envVars){ this.addToEnvVars(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildEnvVars instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Env[] getEnvVars(){
            int size = envVars != null ? envVars.size() : 0;
io.dekorate.kubernetes.config.Env[] result = new io.dekorate.kubernetes.config.Env[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Env,?> builder : envVars) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Env[] buildEnvVars(){
            int size = envVars != null ? envVars.size() : 0;
io.dekorate.kubernetes.config.Env[] result = new io.dekorate.kubernetes.config.Env[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Env,?> builder : envVars) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Env buildEnvVar(int index){
            return this.envVars.get(index).build();
    }

    public io.dekorate.kubernetes.config.Env buildFirstEnvVar(){
            return this.envVars.get(0).build();
    }

    public io.dekorate.kubernetes.config.Env buildLastEnvVar(){
            return this.envVars.get(envVars.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.Env buildMatchingEnvVar(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate){
            for (EnvBuilder item: envVars) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingEnvVar(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate){
            for (EnvBuilder item: envVars) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToEnvVars(int index,io.dekorate.kubernetes.config.Env item){
            if (this.envVars == null) {this.envVars = new ArrayList<EnvBuilder>();}
            io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);_visitables.get("envVars").add(index >= 0 ? index : _visitables.get("envVars").size(), builder);this.envVars.add(index >= 0 ? index : envVars.size(), builder); return (A)this;
    }

    public A setToEnvVars(int index,io.dekorate.kubernetes.config.Env item){
            if (this.envVars == null) {this.envVars = new ArrayList<EnvBuilder>();}
            io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);
            if (index < 0 || index >= _visitables.get("envVars").size()) { _visitables.get("envVars").add(builder); } else { _visitables.get("envVars").set(index, builder);}
            if (index < 0 || index >= envVars.size()) { envVars.add(builder); } else { envVars.set(index, builder);}
             return (A)this;
    }

    public A addToEnvVars(io.dekorate.kubernetes.config.Env... items){
            if (this.envVars == null) {this.envVars = new ArrayList<EnvBuilder>();}
            for (io.dekorate.kubernetes.config.Env item : items) {io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);_visitables.get("envVars").add(builder);this.envVars.add(builder);} return (A)this;
    }

    public A addAllToEnvVars(Collection<io.dekorate.kubernetes.config.Env> items){
            if (this.envVars == null) {this.envVars = new ArrayList<EnvBuilder>();}
            for (io.dekorate.kubernetes.config.Env item : items) {io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);_visitables.get("envVars").add(builder);this.envVars.add(builder);} return (A)this;
    }

    public A removeFromEnvVars(io.dekorate.kubernetes.config.Env... items){
            for (io.dekorate.kubernetes.config.Env item : items) {io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);_visitables.get("envVars").remove(builder);if (this.envVars != null) {this.envVars.remove(builder);}} return (A)this;
    }

    public A removeAllFromEnvVars(Collection<io.dekorate.kubernetes.config.Env> items){
            for (io.dekorate.kubernetes.config.Env item : items) {io.dekorate.kubernetes.config.EnvBuilder builder = new io.dekorate.kubernetes.config.EnvBuilder(item);_visitables.get("envVars").remove(builder);if (this.envVars != null) {this.envVars.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromEnvVars(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate){
            if (envVars == null) return (A) this;
            final Iterator<EnvBuilder> each = envVars.iterator();
            final List visitables = _visitables.get("envVars");
            while (each.hasNext()) {
              EnvBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasEnvVars(){
            return envVars != null && !envVars.isEmpty();
    }

    public A addNewEnvVar(String name,String value,String secret,String configmap,String field){
            return (A)addToEnvVars(new Env(name, value, secret, configmap, field));
    }

    public BaseConfigFluent.EnvVarsNested<A> addNewEnvVar(){
            return new EnvVarsNestedImpl();
    }

    public BaseConfigFluent.EnvVarsNested<A> addNewEnvVarLike(io.dekorate.kubernetes.config.Env item){
            return new EnvVarsNestedImpl(-1, item);
    }

    public BaseConfigFluent.EnvVarsNested<A> setNewEnvVarLike(int index,io.dekorate.kubernetes.config.Env item){
            return new EnvVarsNestedImpl(index, item);
    }

    public BaseConfigFluent.EnvVarsNested<A> editEnvVar(int index){
            if (envVars.size() <= index) throw new RuntimeException("Can't edit envVars. Index exceeds size.");
            return setNewEnvVarLike(index, buildEnvVar(index));
    }

    public BaseConfigFluent.EnvVarsNested<A> editFirstEnvVar(){
            if (envVars.size() == 0) throw new RuntimeException("Can't edit first envVars. The list is empty.");
            return setNewEnvVarLike(0, buildEnvVar(0));
    }

    public BaseConfigFluent.EnvVarsNested<A> editLastEnvVar(){
            int index = envVars.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last envVars. The list is empty.");
            return setNewEnvVarLike(index, buildEnvVar(index));
    }

    public BaseConfigFluent.EnvVarsNested<A> editMatchingEnvVar(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate){
            int index = -1;
            for (int i=0;i<envVars.size();i++) { 
            if (predicate.apply(envVars.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching envVars. No match found.");
            return setNewEnvVarLike(index, buildEnvVar(index));
    }

    public String getWorkingDir(){
            return this.workingDir;
    }

    public A withWorkingDir(String workingDir){
            this.workingDir=workingDir; return (A) this;
    }

    public Boolean hasWorkingDir(){
            return this.workingDir != null;
    }

    public A withNewWorkingDir(String arg1){
            return (A)withWorkingDir(new String(arg1));
    }

    public A withNewWorkingDir(StringBuilder arg1){
            return (A)withWorkingDir(new String(arg1));
    }

    public A withNewWorkingDir(StringBuffer arg1){
            return (A)withWorkingDir(new String(arg1));
    }

    public A withCommand(String... command){
            if (this.command != null) {this.command.clear();}
            if (command != null) {for (String item :command){ this.addToCommand(item);}} return (A) this;
    }

    public String[] getCommand(){
            //This needs to work with primitives, so we use arrays.
int size = command != null ? command.size() : 0;
String[] result = new String[size];
if (size == 0) {
   return result;
}
int index = 0;
for (String item : command) {
    result[index++]=item;
}
return result;

    }

    public A addToCommand(int index,String item){
            if (this.command == null) {this.command = new ArrayList<String>();}
            this.command.add(index, item);
            return (A)this;
    }

    public A setToCommand(int index,String item){
            if (this.command == null) {this.command = new ArrayList<String>();}
            this.command.set(index, item); return (A)this;
    }

    public A addToCommand(String... items){
            if (this.command == null) {this.command = new ArrayList<String>();}
            for (String item : items) {this.command.add(item);} return (A)this;
    }

    public A addAllToCommand(Collection<String> items){
            if (this.command == null) {this.command = new ArrayList<String>();}
            for (String item : items) {this.command.add(item);} return (A)this;
    }

    public A removeFromCommand(String... items){
            for (String item : items) {if (this.command!= null){ this.command.remove(item);}} return (A)this;
    }

    public A removeAllFromCommand(Collection<String> items){
            for (String item : items) {if (this.command!= null){ this.command.remove(item);}} return (A)this;
    }

    public Boolean hasCommand(){
            return command != null && !command.isEmpty();
    }

    public A addNewCommand(String arg1){
            return (A)addToCommand(new String(arg1));
    }

    public A addNewCommand(StringBuilder arg1){
            return (A)addToCommand(new String(arg1));
    }

    public A addNewCommand(StringBuffer arg1){
            return (A)addToCommand(new String(arg1));
    }

    public A withArguments(String... arguments){
            if (this.arguments != null) {this.arguments.clear();}
            if (arguments != null) {for (String item :arguments){ this.addToArguments(item);}} return (A) this;
    }

    public String[] getArguments(){
            //This needs to work with primitives, so we use arrays.
int size = arguments != null ? arguments.size() : 0;
String[] result = new String[size];
if (size == 0) {
   return result;
}
int index = 0;
for (String item : arguments) {
    result[index++]=item;
}
return result;

    }

    public A addToArguments(int index,String item){
            if (this.arguments == null) {this.arguments = new ArrayList<String>();}
            this.arguments.add(index, item);
            return (A)this;
    }

    public A setToArguments(int index,String item){
            if (this.arguments == null) {this.arguments = new ArrayList<String>();}
            this.arguments.set(index, item); return (A)this;
    }

    public A addToArguments(String... items){
            if (this.arguments == null) {this.arguments = new ArrayList<String>();}
            for (String item : items) {this.arguments.add(item);} return (A)this;
    }

    public A addAllToArguments(Collection<String> items){
            if (this.arguments == null) {this.arguments = new ArrayList<String>();}
            for (String item : items) {this.arguments.add(item);} return (A)this;
    }

    public A removeFromArguments(String... items){
            for (String item : items) {if (this.arguments!= null){ this.arguments.remove(item);}} return (A)this;
    }

    public A removeAllFromArguments(Collection<String> items){
            for (String item : items) {if (this.arguments!= null){ this.arguments.remove(item);}} return (A)this;
    }

    public Boolean hasArguments(){
            return arguments != null && !arguments.isEmpty();
    }

    public A addNewArgument(String arg1){
            return (A)addToArguments(new String(arg1));
    }

    public A addNewArgument(StringBuilder arg1){
            return (A)addToArguments(new String(arg1));
    }

    public A addNewArgument(StringBuffer arg1){
            return (A)addToArguments(new String(arg1));
    }

    public int getReplicas(){
            return this.replicas;
    }

    public A withReplicas(int replicas){
            this.replicas=replicas; return (A) this;
    }

    public Boolean hasReplicas(){
            return true;
    }

    public String getServiceAccount(){
            return this.serviceAccount;
    }

    public A withServiceAccount(String serviceAccount){
            this.serviceAccount=serviceAccount; return (A) this;
    }

    public Boolean hasServiceAccount(){
            return this.serviceAccount != null;
    }

    public A withNewServiceAccount(String arg1){
            return (A)withServiceAccount(new String(arg1));
    }

    public A withNewServiceAccount(StringBuilder arg1){
            return (A)withServiceAccount(new String(arg1));
    }

    public A withNewServiceAccount(StringBuffer arg1){
            return (A)withServiceAccount(new String(arg1));
    }

    public String getHost(){
            return this.host;
    }

    public A withHost(String host){
            this.host=host; return (A) this;
    }

    public Boolean hasHost(){
            return this.host != null;
    }

    public A withNewHost(String arg1){
            return (A)withHost(new String(arg1));
    }

    public A withNewHost(StringBuilder arg1){
            return (A)withHost(new String(arg1));
    }

    public A withNewHost(StringBuffer arg1){
            return (A)withHost(new String(arg1));
    }

    public A withPorts(io.dekorate.kubernetes.config.Port... ports){
            if (this.ports != null) {this.ports.clear();}
            if (ports != null) {for (io.dekorate.kubernetes.config.Port item :ports){ this.addToPorts(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildPorts instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Port[] getPorts(){
            int size = ports != null ? ports.size() : 0;
io.dekorate.kubernetes.config.Port[] result = new io.dekorate.kubernetes.config.Port[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Port,?> builder : ports) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Port[] buildPorts(){
            int size = ports != null ? ports.size() : 0;
io.dekorate.kubernetes.config.Port[] result = new io.dekorate.kubernetes.config.Port[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Port,?> builder : ports) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Port buildPort(int index){
            return this.ports.get(index).build();
    }

    public io.dekorate.kubernetes.config.Port buildFirstPort(){
            return this.ports.get(0).build();
    }

    public io.dekorate.kubernetes.config.Port buildLastPort(){
            return this.ports.get(ports.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.Port buildMatchingPort(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate){
            for (PortBuilder item: ports) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingPort(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate){
            for (PortBuilder item: ports) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToPorts(int index,io.dekorate.kubernetes.config.Port item){
            if (this.ports == null) {this.ports = new ArrayList<PortBuilder>();}
            io.dekorate.kubernetes.config.PortBuilder builder = new io.dekorate.kubernetes.config.PortBuilder(item);_visitables.get("ports").add(index >= 0 ? index : _visitables.get("ports").size(), builder);this.ports.add(index >= 0 ? index : ports.size(), builder); return (A)this;
    }

    public A setToPorts(int index,io.dekorate.kubernetes.config.Port item){
            if (this.ports == null) {this.ports = new ArrayList<PortBuilder>();}
            io.dekorate.kubernetes.config.PortBuilder builder = new io.dekorate.kubernetes.config.PortBuilder(item);
            if (index < 0 || index >= _visitables.get("ports").size()) { _visitables.get("ports").add(builder); } else { _visitables.get("ports").set(index, builder);}
            if (index < 0 || index >= ports.size()) { ports.add(builder); } else { ports.set(index, builder);}
             return (A)this;
    }

    public A addToPorts(io.dekorate.kubernetes.config.Port... items){
            if (this.ports == null) {this.ports = new ArrayList<PortBuilder>();}
            for (io.dekorate.kubernetes.config.Port item : items) {io.dekorate.kubernetes.config.PortBuilder builder = new io.dekorate.kubernetes.config.PortBuilder(item);_visitables.get("ports").add(builder);this.ports.add(builder);} return (A)this;
    }

    public A addAllToPorts(Collection<io.dekorate.kubernetes.config.Port> items){
            if (this.ports == null) {this.ports = new ArrayList<PortBuilder>();}
            for (io.dekorate.kubernetes.config.Port item : items) {io.dekorate.kubernetes.config.PortBuilder builder = new io.dekorate.kubernetes.config.PortBuilder(item);_visitables.get("ports").add(builder);this.ports.add(builder);} return (A)this;
    }

    public A removeFromPorts(io.dekorate.kubernetes.config.Port... items){
            for (io.dekorate.kubernetes.config.Port item : items) {io.dekorate.kubernetes.config.PortBuilder builder = new io.dekorate.kubernetes.config.PortBuilder(item);_visitables.get("ports").remove(builder);if (this.ports != null) {this.ports.remove(builder);}} return (A)this;
    }

    public A removeAllFromPorts(Collection<io.dekorate.kubernetes.config.Port> items){
            for (io.dekorate.kubernetes.config.Port item : items) {io.dekorate.kubernetes.config.PortBuilder builder = new io.dekorate.kubernetes.config.PortBuilder(item);_visitables.get("ports").remove(builder);if (this.ports != null) {this.ports.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromPorts(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate){
            if (ports == null) return (A) this;
            final Iterator<PortBuilder> each = ports.iterator();
            final List visitables = _visitables.get("ports");
            while (each.hasNext()) {
              PortBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasPorts(){
            return ports != null && !ports.isEmpty();
    }

    public BaseConfigFluent.PortsNested<A> addNewPort(){
            return new PortsNestedImpl();
    }

    public BaseConfigFluent.PortsNested<A> addNewPortLike(io.dekorate.kubernetes.config.Port item){
            return new PortsNestedImpl(-1, item);
    }

    public BaseConfigFluent.PortsNested<A> setNewPortLike(int index,io.dekorate.kubernetes.config.Port item){
            return new PortsNestedImpl(index, item);
    }

    public BaseConfigFluent.PortsNested<A> editPort(int index){
            if (ports.size() <= index) throw new RuntimeException("Can't edit ports. Index exceeds size.");
            return setNewPortLike(index, buildPort(index));
    }

    public BaseConfigFluent.PortsNested<A> editFirstPort(){
            if (ports.size() == 0) throw new RuntimeException("Can't edit first ports. The list is empty.");
            return setNewPortLike(0, buildPort(0));
    }

    public BaseConfigFluent.PortsNested<A> editLastPort(){
            int index = ports.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last ports. The list is empty.");
            return setNewPortLike(index, buildPort(index));
    }

    public BaseConfigFluent.PortsNested<A> editMatchingPort(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate){
            int index = -1;
            for (int i=0;i<ports.size();i++) { 
            if (predicate.apply(ports.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching ports. No match found.");
            return setNewPortLike(index, buildPort(index));
    }

    public ServiceType getServiceType(){
            return this.serviceType;
    }

    public A withServiceType(ServiceType serviceType){
            this.serviceType=serviceType; return (A) this;
    }

    public Boolean hasServiceType(){
            return this.serviceType != null;
    }

    public A withPvcVolumes(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume... pvcVolumes){
            if (this.pvcVolumes != null) {this.pvcVolumes.clear();}
            if (pvcVolumes != null) {for (io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item :pvcVolumes){ this.addToPvcVolumes(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildPvcVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] getPvcVolumes(){
            int size = pvcVolumes != null ? pvcVolumes.size() : 0;
io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] result = new io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.PersistentVolumeClaimVolume,?> builder : pvcVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] buildPvcVolumes(){
            int size = pvcVolumes != null ? pvcVolumes.size() : 0;
io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[] result = new io.dekorate.kubernetes.config.PersistentVolumeClaimVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.PersistentVolumeClaimVolume,?> builder : pvcVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume buildPvcVolume(int index){
            return this.pvcVolumes.get(index).build();
    }

    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume buildFirstPvcVolume(){
            return this.pvcVolumes.get(0).build();
    }

    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume buildLastPvcVolume(){
            return this.pvcVolumes.get(pvcVolumes.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.PersistentVolumeClaimVolume buildMatchingPvcVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<PersistentVolumeClaimVolumeBuilder> predicate){
            for (PersistentVolumeClaimVolumeBuilder item: pvcVolumes) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingPvcVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<PersistentVolumeClaimVolumeBuilder> predicate){
            for (PersistentVolumeClaimVolumeBuilder item: pvcVolumes) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToPvcVolumes(int index,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item){
            if (this.pvcVolumes == null) {this.pvcVolumes = new ArrayList<PersistentVolumeClaimVolumeBuilder>();}
            io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder builder = new io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder(item);_visitables.get("pvcVolumes").add(index >= 0 ? index : _visitables.get("pvcVolumes").size(), builder);this.pvcVolumes.add(index >= 0 ? index : pvcVolumes.size(), builder); return (A)this;
    }

    public A setToPvcVolumes(int index,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item){
            if (this.pvcVolumes == null) {this.pvcVolumes = new ArrayList<PersistentVolumeClaimVolumeBuilder>();}
            io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder builder = new io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder(item);
            if (index < 0 || index >= _visitables.get("pvcVolumes").size()) { _visitables.get("pvcVolumes").add(builder); } else { _visitables.get("pvcVolumes").set(index, builder);}
            if (index < 0 || index >= pvcVolumes.size()) { pvcVolumes.add(builder); } else { pvcVolumes.set(index, builder);}
             return (A)this;
    }

    public A addToPvcVolumes(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume... items){
            if (this.pvcVolumes == null) {this.pvcVolumes = new ArrayList<PersistentVolumeClaimVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item : items) {io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder builder = new io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder(item);_visitables.get("pvcVolumes").add(builder);this.pvcVolumes.add(builder);} return (A)this;
    }

    public A addAllToPvcVolumes(Collection<io.dekorate.kubernetes.config.PersistentVolumeClaimVolume> items){
            if (this.pvcVolumes == null) {this.pvcVolumes = new ArrayList<PersistentVolumeClaimVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item : items) {io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder builder = new io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder(item);_visitables.get("pvcVolumes").add(builder);this.pvcVolumes.add(builder);} return (A)this;
    }

    public A removeFromPvcVolumes(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume... items){
            for (io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item : items) {io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder builder = new io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder(item);_visitables.get("pvcVolumes").remove(builder);if (this.pvcVolumes != null) {this.pvcVolumes.remove(builder);}} return (A)this;
    }

    public A removeAllFromPvcVolumes(Collection<io.dekorate.kubernetes.config.PersistentVolumeClaimVolume> items){
            for (io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item : items) {io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder builder = new io.dekorate.kubernetes.config.PersistentVolumeClaimVolumeBuilder(item);_visitables.get("pvcVolumes").remove(builder);if (this.pvcVolumes != null) {this.pvcVolumes.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromPvcVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<PersistentVolumeClaimVolumeBuilder> predicate){
            if (pvcVolumes == null) return (A) this;
            final Iterator<PersistentVolumeClaimVolumeBuilder> each = pvcVolumes.iterator();
            final List visitables = _visitables.get("pvcVolumes");
            while (each.hasNext()) {
              PersistentVolumeClaimVolumeBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasPvcVolumes(){
            return pvcVolumes != null && !pvcVolumes.isEmpty();
    }

    public A addNewPvcVolume(String volumeName,String claimName,boolean readOnly){
            return (A)addToPvcVolumes(new PersistentVolumeClaimVolume(volumeName, claimName, readOnly));
    }

    public BaseConfigFluent.PvcVolumesNested<A> addNewPvcVolume(){
            return new PvcVolumesNestedImpl();
    }

    public BaseConfigFluent.PvcVolumesNested<A> addNewPvcVolumeLike(io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item){
            return new PvcVolumesNestedImpl(-1, item);
    }

    public BaseConfigFluent.PvcVolumesNested<A> setNewPvcVolumeLike(int index,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item){
            return new PvcVolumesNestedImpl(index, item);
    }

    public BaseConfigFluent.PvcVolumesNested<A> editPvcVolume(int index){
            if (pvcVolumes.size() <= index) throw new RuntimeException("Can't edit pvcVolumes. Index exceeds size.");
            return setNewPvcVolumeLike(index, buildPvcVolume(index));
    }

    public BaseConfigFluent.PvcVolumesNested<A> editFirstPvcVolume(){
            if (pvcVolumes.size() == 0) throw new RuntimeException("Can't edit first pvcVolumes. The list is empty.");
            return setNewPvcVolumeLike(0, buildPvcVolume(0));
    }

    public BaseConfigFluent.PvcVolumesNested<A> editLastPvcVolume(){
            int index = pvcVolumes.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last pvcVolumes. The list is empty.");
            return setNewPvcVolumeLike(index, buildPvcVolume(index));
    }

    public BaseConfigFluent.PvcVolumesNested<A> editMatchingPvcVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<PersistentVolumeClaimVolumeBuilder> predicate){
            int index = -1;
            for (int i=0;i<pvcVolumes.size();i++) { 
            if (predicate.apply(pvcVolumes.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching pvcVolumes. No match found.");
            return setNewPvcVolumeLike(index, buildPvcVolume(index));
    }

    public A withSecretVolumes(io.dekorate.kubernetes.config.SecretVolume... secretVolumes){
            if (this.secretVolumes != null) {this.secretVolumes.clear();}
            if (secretVolumes != null) {for (io.dekorate.kubernetes.config.SecretVolume item :secretVolumes){ this.addToSecretVolumes(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildSecretVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.SecretVolume[] getSecretVolumes(){
            int size = secretVolumes != null ? secretVolumes.size() : 0;
io.dekorate.kubernetes.config.SecretVolume[] result = new io.dekorate.kubernetes.config.SecretVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.SecretVolume,?> builder : secretVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.SecretVolume[] buildSecretVolumes(){
            int size = secretVolumes != null ? secretVolumes.size() : 0;
io.dekorate.kubernetes.config.SecretVolume[] result = new io.dekorate.kubernetes.config.SecretVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.SecretVolume,?> builder : secretVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.SecretVolume buildSecretVolume(int index){
            return this.secretVolumes.get(index).build();
    }

    public io.dekorate.kubernetes.config.SecretVolume buildFirstSecretVolume(){
            return this.secretVolumes.get(0).build();
    }

    public io.dekorate.kubernetes.config.SecretVolume buildLastSecretVolume(){
            return this.secretVolumes.get(secretVolumes.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.SecretVolume buildMatchingSecretVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<SecretVolumeBuilder> predicate){
            for (SecretVolumeBuilder item: secretVolumes) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingSecretVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<SecretVolumeBuilder> predicate){
            for (SecretVolumeBuilder item: secretVolumes) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToSecretVolumes(int index,io.dekorate.kubernetes.config.SecretVolume item){
            if (this.secretVolumes == null) {this.secretVolumes = new ArrayList<SecretVolumeBuilder>();}
            io.dekorate.kubernetes.config.SecretVolumeBuilder builder = new io.dekorate.kubernetes.config.SecretVolumeBuilder(item);_visitables.get("secretVolumes").add(index >= 0 ? index : _visitables.get("secretVolumes").size(), builder);this.secretVolumes.add(index >= 0 ? index : secretVolumes.size(), builder); return (A)this;
    }

    public A setToSecretVolumes(int index,io.dekorate.kubernetes.config.SecretVolume item){
            if (this.secretVolumes == null) {this.secretVolumes = new ArrayList<SecretVolumeBuilder>();}
            io.dekorate.kubernetes.config.SecretVolumeBuilder builder = new io.dekorate.kubernetes.config.SecretVolumeBuilder(item);
            if (index < 0 || index >= _visitables.get("secretVolumes").size()) { _visitables.get("secretVolumes").add(builder); } else { _visitables.get("secretVolumes").set(index, builder);}
            if (index < 0 || index >= secretVolumes.size()) { secretVolumes.add(builder); } else { secretVolumes.set(index, builder);}
             return (A)this;
    }

    public A addToSecretVolumes(io.dekorate.kubernetes.config.SecretVolume... items){
            if (this.secretVolumes == null) {this.secretVolumes = new ArrayList<SecretVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.SecretVolume item : items) {io.dekorate.kubernetes.config.SecretVolumeBuilder builder = new io.dekorate.kubernetes.config.SecretVolumeBuilder(item);_visitables.get("secretVolumes").add(builder);this.secretVolumes.add(builder);} return (A)this;
    }

    public A addAllToSecretVolumes(Collection<io.dekorate.kubernetes.config.SecretVolume> items){
            if (this.secretVolumes == null) {this.secretVolumes = new ArrayList<SecretVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.SecretVolume item : items) {io.dekorate.kubernetes.config.SecretVolumeBuilder builder = new io.dekorate.kubernetes.config.SecretVolumeBuilder(item);_visitables.get("secretVolumes").add(builder);this.secretVolumes.add(builder);} return (A)this;
    }

    public A removeFromSecretVolumes(io.dekorate.kubernetes.config.SecretVolume... items){
            for (io.dekorate.kubernetes.config.SecretVolume item : items) {io.dekorate.kubernetes.config.SecretVolumeBuilder builder = new io.dekorate.kubernetes.config.SecretVolumeBuilder(item);_visitables.get("secretVolumes").remove(builder);if (this.secretVolumes != null) {this.secretVolumes.remove(builder);}} return (A)this;
    }

    public A removeAllFromSecretVolumes(Collection<io.dekorate.kubernetes.config.SecretVolume> items){
            for (io.dekorate.kubernetes.config.SecretVolume item : items) {io.dekorate.kubernetes.config.SecretVolumeBuilder builder = new io.dekorate.kubernetes.config.SecretVolumeBuilder(item);_visitables.get("secretVolumes").remove(builder);if (this.secretVolumes != null) {this.secretVolumes.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromSecretVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<SecretVolumeBuilder> predicate){
            if (secretVolumes == null) return (A) this;
            final Iterator<SecretVolumeBuilder> each = secretVolumes.iterator();
            final List visitables = _visitables.get("secretVolumes");
            while (each.hasNext()) {
              SecretVolumeBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasSecretVolumes(){
            return secretVolumes != null && !secretVolumes.isEmpty();
    }

    public A addNewSecretVolume(String volumeName,String secretName,int defaultMode,boolean optional){
            return (A)addToSecretVolumes(new SecretVolume(volumeName, secretName, defaultMode, optional));
    }

    public BaseConfigFluent.SecretVolumesNested<A> addNewSecretVolume(){
            return new SecretVolumesNestedImpl();
    }

    public BaseConfigFluent.SecretVolumesNested<A> addNewSecretVolumeLike(io.dekorate.kubernetes.config.SecretVolume item){
            return new SecretVolumesNestedImpl(-1, item);
    }

    public BaseConfigFluent.SecretVolumesNested<A> setNewSecretVolumeLike(int index,io.dekorate.kubernetes.config.SecretVolume item){
            return new SecretVolumesNestedImpl(index, item);
    }

    public BaseConfigFluent.SecretVolumesNested<A> editSecretVolume(int index){
            if (secretVolumes.size() <= index) throw new RuntimeException("Can't edit secretVolumes. Index exceeds size.");
            return setNewSecretVolumeLike(index, buildSecretVolume(index));
    }

    public BaseConfigFluent.SecretVolumesNested<A> editFirstSecretVolume(){
            if (secretVolumes.size() == 0) throw new RuntimeException("Can't edit first secretVolumes. The list is empty.");
            return setNewSecretVolumeLike(0, buildSecretVolume(0));
    }

    public BaseConfigFluent.SecretVolumesNested<A> editLastSecretVolume(){
            int index = secretVolumes.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last secretVolumes. The list is empty.");
            return setNewSecretVolumeLike(index, buildSecretVolume(index));
    }

    public BaseConfigFluent.SecretVolumesNested<A> editMatchingSecretVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<SecretVolumeBuilder> predicate){
            int index = -1;
            for (int i=0;i<secretVolumes.size();i++) { 
            if (predicate.apply(secretVolumes.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching secretVolumes. No match found.");
            return setNewSecretVolumeLike(index, buildSecretVolume(index));
    }

    public A withConfigMapVolumes(io.dekorate.kubernetes.config.ConfigMapVolume... configMapVolumes){
            if (this.configMapVolumes != null) {this.configMapVolumes.clear();}
            if (configMapVolumes != null) {for (io.dekorate.kubernetes.config.ConfigMapVolume item :configMapVolumes){ this.addToConfigMapVolumes(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildConfigMapVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.ConfigMapVolume[] getConfigMapVolumes(){
            int size = configMapVolumes != null ? configMapVolumes.size() : 0;
io.dekorate.kubernetes.config.ConfigMapVolume[] result = new io.dekorate.kubernetes.config.ConfigMapVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.ConfigMapVolume,?> builder : configMapVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.ConfigMapVolume[] buildConfigMapVolumes(){
            int size = configMapVolumes != null ? configMapVolumes.size() : 0;
io.dekorate.kubernetes.config.ConfigMapVolume[] result = new io.dekorate.kubernetes.config.ConfigMapVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.ConfigMapVolume,?> builder : configMapVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.ConfigMapVolume buildConfigMapVolume(int index){
            return this.configMapVolumes.get(index).build();
    }

    public io.dekorate.kubernetes.config.ConfigMapVolume buildFirstConfigMapVolume(){
            return this.configMapVolumes.get(0).build();
    }

    public io.dekorate.kubernetes.config.ConfigMapVolume buildLastConfigMapVolume(){
            return this.configMapVolumes.get(configMapVolumes.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.ConfigMapVolume buildMatchingConfigMapVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<ConfigMapVolumeBuilder> predicate){
            for (ConfigMapVolumeBuilder item: configMapVolumes) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingConfigMapVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<ConfigMapVolumeBuilder> predicate){
            for (ConfigMapVolumeBuilder item: configMapVolumes) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToConfigMapVolumes(int index,io.dekorate.kubernetes.config.ConfigMapVolume item){
            if (this.configMapVolumes == null) {this.configMapVolumes = new ArrayList<ConfigMapVolumeBuilder>();}
            io.dekorate.kubernetes.config.ConfigMapVolumeBuilder builder = new io.dekorate.kubernetes.config.ConfigMapVolumeBuilder(item);_visitables.get("configMapVolumes").add(index >= 0 ? index : _visitables.get("configMapVolumes").size(), builder);this.configMapVolumes.add(index >= 0 ? index : configMapVolumes.size(), builder); return (A)this;
    }

    public A setToConfigMapVolumes(int index,io.dekorate.kubernetes.config.ConfigMapVolume item){
            if (this.configMapVolumes == null) {this.configMapVolumes = new ArrayList<ConfigMapVolumeBuilder>();}
            io.dekorate.kubernetes.config.ConfigMapVolumeBuilder builder = new io.dekorate.kubernetes.config.ConfigMapVolumeBuilder(item);
            if (index < 0 || index >= _visitables.get("configMapVolumes").size()) { _visitables.get("configMapVolumes").add(builder); } else { _visitables.get("configMapVolumes").set(index, builder);}
            if (index < 0 || index >= configMapVolumes.size()) { configMapVolumes.add(builder); } else { configMapVolumes.set(index, builder);}
             return (A)this;
    }

    public A addToConfigMapVolumes(io.dekorate.kubernetes.config.ConfigMapVolume... items){
            if (this.configMapVolumes == null) {this.configMapVolumes = new ArrayList<ConfigMapVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.ConfigMapVolume item : items) {io.dekorate.kubernetes.config.ConfigMapVolumeBuilder builder = new io.dekorate.kubernetes.config.ConfigMapVolumeBuilder(item);_visitables.get("configMapVolumes").add(builder);this.configMapVolumes.add(builder);} return (A)this;
    }

    public A addAllToConfigMapVolumes(Collection<io.dekorate.kubernetes.config.ConfigMapVolume> items){
            if (this.configMapVolumes == null) {this.configMapVolumes = new ArrayList<ConfigMapVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.ConfigMapVolume item : items) {io.dekorate.kubernetes.config.ConfigMapVolumeBuilder builder = new io.dekorate.kubernetes.config.ConfigMapVolumeBuilder(item);_visitables.get("configMapVolumes").add(builder);this.configMapVolumes.add(builder);} return (A)this;
    }

    public A removeFromConfigMapVolumes(io.dekorate.kubernetes.config.ConfigMapVolume... items){
            for (io.dekorate.kubernetes.config.ConfigMapVolume item : items) {io.dekorate.kubernetes.config.ConfigMapVolumeBuilder builder = new io.dekorate.kubernetes.config.ConfigMapVolumeBuilder(item);_visitables.get("configMapVolumes").remove(builder);if (this.configMapVolumes != null) {this.configMapVolumes.remove(builder);}} return (A)this;
    }

    public A removeAllFromConfigMapVolumes(Collection<io.dekorate.kubernetes.config.ConfigMapVolume> items){
            for (io.dekorate.kubernetes.config.ConfigMapVolume item : items) {io.dekorate.kubernetes.config.ConfigMapVolumeBuilder builder = new io.dekorate.kubernetes.config.ConfigMapVolumeBuilder(item);_visitables.get("configMapVolumes").remove(builder);if (this.configMapVolumes != null) {this.configMapVolumes.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromConfigMapVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<ConfigMapVolumeBuilder> predicate){
            if (configMapVolumes == null) return (A) this;
            final Iterator<ConfigMapVolumeBuilder> each = configMapVolumes.iterator();
            final List visitables = _visitables.get("configMapVolumes");
            while (each.hasNext()) {
              ConfigMapVolumeBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasConfigMapVolumes(){
            return configMapVolumes != null && !configMapVolumes.isEmpty();
    }

    public A addNewConfigMapVolume(String volumeName,String configMapName,int defaultMode,boolean optional){
            return (A)addToConfigMapVolumes(new ConfigMapVolume(volumeName, configMapName, defaultMode, optional));
    }

    public BaseConfigFluent.ConfigMapVolumesNested<A> addNewConfigMapVolume(){
            return new ConfigMapVolumesNestedImpl();
    }

    public BaseConfigFluent.ConfigMapVolumesNested<A> addNewConfigMapVolumeLike(io.dekorate.kubernetes.config.ConfigMapVolume item){
            return new ConfigMapVolumesNestedImpl(-1, item);
    }

    public BaseConfigFluent.ConfigMapVolumesNested<A> setNewConfigMapVolumeLike(int index,io.dekorate.kubernetes.config.ConfigMapVolume item){
            return new ConfigMapVolumesNestedImpl(index, item);
    }

    public BaseConfigFluent.ConfigMapVolumesNested<A> editConfigMapVolume(int index){
            if (configMapVolumes.size() <= index) throw new RuntimeException("Can't edit configMapVolumes. Index exceeds size.");
            return setNewConfigMapVolumeLike(index, buildConfigMapVolume(index));
    }

    public BaseConfigFluent.ConfigMapVolumesNested<A> editFirstConfigMapVolume(){
            if (configMapVolumes.size() == 0) throw new RuntimeException("Can't edit first configMapVolumes. The list is empty.");
            return setNewConfigMapVolumeLike(0, buildConfigMapVolume(0));
    }

    public BaseConfigFluent.ConfigMapVolumesNested<A> editLastConfigMapVolume(){
            int index = configMapVolumes.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last configMapVolumes. The list is empty.");
            return setNewConfigMapVolumeLike(index, buildConfigMapVolume(index));
    }

    public BaseConfigFluent.ConfigMapVolumesNested<A> editMatchingConfigMapVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<ConfigMapVolumeBuilder> predicate){
            int index = -1;
            for (int i=0;i<configMapVolumes.size();i++) { 
            if (predicate.apply(configMapVolumes.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching configMapVolumes. No match found.");
            return setNewConfigMapVolumeLike(index, buildConfigMapVolume(index));
    }

    public A withGitRepoVolumes(io.dekorate.kubernetes.config.GitRepoVolume... gitRepoVolumes){
            if (this.gitRepoVolumes != null) {this.gitRepoVolumes.clear();}
            if (gitRepoVolumes != null) {for (io.dekorate.kubernetes.config.GitRepoVolume item :gitRepoVolumes){ this.addToGitRepoVolumes(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildGitRepoVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.GitRepoVolume[] getGitRepoVolumes(){
            int size = gitRepoVolumes != null ? gitRepoVolumes.size() : 0;
io.dekorate.kubernetes.config.GitRepoVolume[] result = new io.dekorate.kubernetes.config.GitRepoVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.GitRepoVolume,?> builder : gitRepoVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.GitRepoVolume[] buildGitRepoVolumes(){
            int size = gitRepoVolumes != null ? gitRepoVolumes.size() : 0;
io.dekorate.kubernetes.config.GitRepoVolume[] result = new io.dekorate.kubernetes.config.GitRepoVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.GitRepoVolume,?> builder : gitRepoVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.GitRepoVolume buildGitRepoVolume(int index){
            return this.gitRepoVolumes.get(index).build();
    }

    public io.dekorate.kubernetes.config.GitRepoVolume buildFirstGitRepoVolume(){
            return this.gitRepoVolumes.get(0).build();
    }

    public io.dekorate.kubernetes.config.GitRepoVolume buildLastGitRepoVolume(){
            return this.gitRepoVolumes.get(gitRepoVolumes.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.GitRepoVolume buildMatchingGitRepoVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<GitRepoVolumeBuilder> predicate){
            for (GitRepoVolumeBuilder item: gitRepoVolumes) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingGitRepoVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<GitRepoVolumeBuilder> predicate){
            for (GitRepoVolumeBuilder item: gitRepoVolumes) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToGitRepoVolumes(int index,io.dekorate.kubernetes.config.GitRepoVolume item){
            if (this.gitRepoVolumes == null) {this.gitRepoVolumes = new ArrayList<GitRepoVolumeBuilder>();}
            io.dekorate.kubernetes.config.GitRepoVolumeBuilder builder = new io.dekorate.kubernetes.config.GitRepoVolumeBuilder(item);_visitables.get("gitRepoVolumes").add(index >= 0 ? index : _visitables.get("gitRepoVolumes").size(), builder);this.gitRepoVolumes.add(index >= 0 ? index : gitRepoVolumes.size(), builder); return (A)this;
    }

    public A setToGitRepoVolumes(int index,io.dekorate.kubernetes.config.GitRepoVolume item){
            if (this.gitRepoVolumes == null) {this.gitRepoVolumes = new ArrayList<GitRepoVolumeBuilder>();}
            io.dekorate.kubernetes.config.GitRepoVolumeBuilder builder = new io.dekorate.kubernetes.config.GitRepoVolumeBuilder(item);
            if (index < 0 || index >= _visitables.get("gitRepoVolumes").size()) { _visitables.get("gitRepoVolumes").add(builder); } else { _visitables.get("gitRepoVolumes").set(index, builder);}
            if (index < 0 || index >= gitRepoVolumes.size()) { gitRepoVolumes.add(builder); } else { gitRepoVolumes.set(index, builder);}
             return (A)this;
    }

    public A addToGitRepoVolumes(io.dekorate.kubernetes.config.GitRepoVolume... items){
            if (this.gitRepoVolumes == null) {this.gitRepoVolumes = new ArrayList<GitRepoVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.GitRepoVolume item : items) {io.dekorate.kubernetes.config.GitRepoVolumeBuilder builder = new io.dekorate.kubernetes.config.GitRepoVolumeBuilder(item);_visitables.get("gitRepoVolumes").add(builder);this.gitRepoVolumes.add(builder);} return (A)this;
    }

    public A addAllToGitRepoVolumes(Collection<io.dekorate.kubernetes.config.GitRepoVolume> items){
            if (this.gitRepoVolumes == null) {this.gitRepoVolumes = new ArrayList<GitRepoVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.GitRepoVolume item : items) {io.dekorate.kubernetes.config.GitRepoVolumeBuilder builder = new io.dekorate.kubernetes.config.GitRepoVolumeBuilder(item);_visitables.get("gitRepoVolumes").add(builder);this.gitRepoVolumes.add(builder);} return (A)this;
    }

    public A removeFromGitRepoVolumes(io.dekorate.kubernetes.config.GitRepoVolume... items){
            for (io.dekorate.kubernetes.config.GitRepoVolume item : items) {io.dekorate.kubernetes.config.GitRepoVolumeBuilder builder = new io.dekorate.kubernetes.config.GitRepoVolumeBuilder(item);_visitables.get("gitRepoVolumes").remove(builder);if (this.gitRepoVolumes != null) {this.gitRepoVolumes.remove(builder);}} return (A)this;
    }

    public A removeAllFromGitRepoVolumes(Collection<io.dekorate.kubernetes.config.GitRepoVolume> items){
            for (io.dekorate.kubernetes.config.GitRepoVolume item : items) {io.dekorate.kubernetes.config.GitRepoVolumeBuilder builder = new io.dekorate.kubernetes.config.GitRepoVolumeBuilder(item);_visitables.get("gitRepoVolumes").remove(builder);if (this.gitRepoVolumes != null) {this.gitRepoVolumes.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromGitRepoVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<GitRepoVolumeBuilder> predicate){
            if (gitRepoVolumes == null) return (A) this;
            final Iterator<GitRepoVolumeBuilder> each = gitRepoVolumes.iterator();
            final List visitables = _visitables.get("gitRepoVolumes");
            while (each.hasNext()) {
              GitRepoVolumeBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasGitRepoVolumes(){
            return gitRepoVolumes != null && !gitRepoVolumes.isEmpty();
    }

    public A addNewGitRepoVolume(String volumeName,String repository,String directory,String revision){
            return (A)addToGitRepoVolumes(new GitRepoVolume(volumeName, repository, directory, revision));
    }

    public BaseConfigFluent.GitRepoVolumesNested<A> addNewGitRepoVolume(){
            return new GitRepoVolumesNestedImpl();
    }

    public BaseConfigFluent.GitRepoVolumesNested<A> addNewGitRepoVolumeLike(io.dekorate.kubernetes.config.GitRepoVolume item){
            return new GitRepoVolumesNestedImpl(-1, item);
    }

    public BaseConfigFluent.GitRepoVolumesNested<A> setNewGitRepoVolumeLike(int index,io.dekorate.kubernetes.config.GitRepoVolume item){
            return new GitRepoVolumesNestedImpl(index, item);
    }

    public BaseConfigFluent.GitRepoVolumesNested<A> editGitRepoVolume(int index){
            if (gitRepoVolumes.size() <= index) throw new RuntimeException("Can't edit gitRepoVolumes. Index exceeds size.");
            return setNewGitRepoVolumeLike(index, buildGitRepoVolume(index));
    }

    public BaseConfigFluent.GitRepoVolumesNested<A> editFirstGitRepoVolume(){
            if (gitRepoVolumes.size() == 0) throw new RuntimeException("Can't edit first gitRepoVolumes. The list is empty.");
            return setNewGitRepoVolumeLike(0, buildGitRepoVolume(0));
    }

    public BaseConfigFluent.GitRepoVolumesNested<A> editLastGitRepoVolume(){
            int index = gitRepoVolumes.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last gitRepoVolumes. The list is empty.");
            return setNewGitRepoVolumeLike(index, buildGitRepoVolume(index));
    }

    public BaseConfigFluent.GitRepoVolumesNested<A> editMatchingGitRepoVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<GitRepoVolumeBuilder> predicate){
            int index = -1;
            for (int i=0;i<gitRepoVolumes.size();i++) { 
            if (predicate.apply(gitRepoVolumes.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching gitRepoVolumes. No match found.");
            return setNewGitRepoVolumeLike(index, buildGitRepoVolume(index));
    }

    public A withAwsElasticBlockStoreVolumes(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume... awsElasticBlockStoreVolumes){
            if (this.awsElasticBlockStoreVolumes != null) {this.awsElasticBlockStoreVolumes.clear();}
            if (awsElasticBlockStoreVolumes != null) {for (io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item :awsElasticBlockStoreVolumes){ this.addToAwsElasticBlockStoreVolumes(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildAwsElasticBlockStoreVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] getAwsElasticBlockStoreVolumes(){
            int size = awsElasticBlockStoreVolumes != null ? awsElasticBlockStoreVolumes.size() : 0;
io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] result = new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume,?> builder : awsElasticBlockStoreVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] buildAwsElasticBlockStoreVolumes(){
            int size = awsElasticBlockStoreVolumes != null ? awsElasticBlockStoreVolumes.size() : 0;
io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[] result = new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume,?> builder : awsElasticBlockStoreVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume buildAwsElasticBlockStoreVolume(int index){
            return this.awsElasticBlockStoreVolumes.get(index).build();
    }

    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume buildFirstAwsElasticBlockStoreVolume(){
            return this.awsElasticBlockStoreVolumes.get(0).build();
    }

    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume buildLastAwsElasticBlockStoreVolume(){
            return this.awsElasticBlockStoreVolumes.get(awsElasticBlockStoreVolumes.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume buildMatchingAwsElasticBlockStoreVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AwsElasticBlockStoreVolumeBuilder> predicate){
            for (AwsElasticBlockStoreVolumeBuilder item: awsElasticBlockStoreVolumes) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingAwsElasticBlockStoreVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AwsElasticBlockStoreVolumeBuilder> predicate){
            for (AwsElasticBlockStoreVolumeBuilder item: awsElasticBlockStoreVolumes) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToAwsElasticBlockStoreVolumes(int index,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item){
            if (this.awsElasticBlockStoreVolumes == null) {this.awsElasticBlockStoreVolumes = new ArrayList<AwsElasticBlockStoreVolumeBuilder>();}
            io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder builder = new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder(item);_visitables.get("awsElasticBlockStoreVolumes").add(index >= 0 ? index : _visitables.get("awsElasticBlockStoreVolumes").size(), builder);this.awsElasticBlockStoreVolumes.add(index >= 0 ? index : awsElasticBlockStoreVolumes.size(), builder); return (A)this;
    }

    public A setToAwsElasticBlockStoreVolumes(int index,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item){
            if (this.awsElasticBlockStoreVolumes == null) {this.awsElasticBlockStoreVolumes = new ArrayList<AwsElasticBlockStoreVolumeBuilder>();}
            io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder builder = new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder(item);
            if (index < 0 || index >= _visitables.get("awsElasticBlockStoreVolumes").size()) { _visitables.get("awsElasticBlockStoreVolumes").add(builder); } else { _visitables.get("awsElasticBlockStoreVolumes").set(index, builder);}
            if (index < 0 || index >= awsElasticBlockStoreVolumes.size()) { awsElasticBlockStoreVolumes.add(builder); } else { awsElasticBlockStoreVolumes.set(index, builder);}
             return (A)this;
    }

    public A addToAwsElasticBlockStoreVolumes(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume... items){
            if (this.awsElasticBlockStoreVolumes == null) {this.awsElasticBlockStoreVolumes = new ArrayList<AwsElasticBlockStoreVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item : items) {io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder builder = new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder(item);_visitables.get("awsElasticBlockStoreVolumes").add(builder);this.awsElasticBlockStoreVolumes.add(builder);} return (A)this;
    }

    public A addAllToAwsElasticBlockStoreVolumes(Collection<io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume> items){
            if (this.awsElasticBlockStoreVolumes == null) {this.awsElasticBlockStoreVolumes = new ArrayList<AwsElasticBlockStoreVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item : items) {io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder builder = new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder(item);_visitables.get("awsElasticBlockStoreVolumes").add(builder);this.awsElasticBlockStoreVolumes.add(builder);} return (A)this;
    }

    public A removeFromAwsElasticBlockStoreVolumes(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume... items){
            for (io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item : items) {io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder builder = new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder(item);_visitables.get("awsElasticBlockStoreVolumes").remove(builder);if (this.awsElasticBlockStoreVolumes != null) {this.awsElasticBlockStoreVolumes.remove(builder);}} return (A)this;
    }

    public A removeAllFromAwsElasticBlockStoreVolumes(Collection<io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume> items){
            for (io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item : items) {io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder builder = new io.dekorate.kubernetes.config.AwsElasticBlockStoreVolumeBuilder(item);_visitables.get("awsElasticBlockStoreVolumes").remove(builder);if (this.awsElasticBlockStoreVolumes != null) {this.awsElasticBlockStoreVolumes.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromAwsElasticBlockStoreVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<AwsElasticBlockStoreVolumeBuilder> predicate){
            if (awsElasticBlockStoreVolumes == null) return (A) this;
            final Iterator<AwsElasticBlockStoreVolumeBuilder> each = awsElasticBlockStoreVolumes.iterator();
            final List visitables = _visitables.get("awsElasticBlockStoreVolumes");
            while (each.hasNext()) {
              AwsElasticBlockStoreVolumeBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasAwsElasticBlockStoreVolumes(){
            return awsElasticBlockStoreVolumes != null && !awsElasticBlockStoreVolumes.isEmpty();
    }

    public A addNewAwsElasticBlockStoreVolume(String volumeName,String volumeId,int partition,String fsType,boolean readOnly){
            return (A)addToAwsElasticBlockStoreVolumes(new AwsElasticBlockStoreVolume(volumeName, volumeId, partition, fsType, readOnly));
    }

    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> addNewAwsElasticBlockStoreVolume(){
            return new AwsElasticBlockStoreVolumesNestedImpl();
    }

    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> addNewAwsElasticBlockStoreVolumeLike(io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item){
            return new AwsElasticBlockStoreVolumesNestedImpl(-1, item);
    }

    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> setNewAwsElasticBlockStoreVolumeLike(int index,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item){
            return new AwsElasticBlockStoreVolumesNestedImpl(index, item);
    }

    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> editAwsElasticBlockStoreVolume(int index){
            if (awsElasticBlockStoreVolumes.size() <= index) throw new RuntimeException("Can't edit awsElasticBlockStoreVolumes. Index exceeds size.");
            return setNewAwsElasticBlockStoreVolumeLike(index, buildAwsElasticBlockStoreVolume(index));
    }

    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> editFirstAwsElasticBlockStoreVolume(){
            if (awsElasticBlockStoreVolumes.size() == 0) throw new RuntimeException("Can't edit first awsElasticBlockStoreVolumes. The list is empty.");
            return setNewAwsElasticBlockStoreVolumeLike(0, buildAwsElasticBlockStoreVolume(0));
    }

    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> editLastAwsElasticBlockStoreVolume(){
            int index = awsElasticBlockStoreVolumes.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last awsElasticBlockStoreVolumes. The list is empty.");
            return setNewAwsElasticBlockStoreVolumeLike(index, buildAwsElasticBlockStoreVolume(index));
    }

    public BaseConfigFluent.AwsElasticBlockStoreVolumesNested<A> editMatchingAwsElasticBlockStoreVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AwsElasticBlockStoreVolumeBuilder> predicate){
            int index = -1;
            for (int i=0;i<awsElasticBlockStoreVolumes.size();i++) { 
            if (predicate.apply(awsElasticBlockStoreVolumes.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching awsElasticBlockStoreVolumes. No match found.");
            return setNewAwsElasticBlockStoreVolumeLike(index, buildAwsElasticBlockStoreVolume(index));
    }

    public A withAzureDiskVolumes(io.dekorate.kubernetes.config.AzureDiskVolume... azureDiskVolumes){
            if (this.azureDiskVolumes != null) {this.azureDiskVolumes.clear();}
            if (azureDiskVolumes != null) {for (io.dekorate.kubernetes.config.AzureDiskVolume item :azureDiskVolumes){ this.addToAzureDiskVolumes(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildAzureDiskVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.AzureDiskVolume[] getAzureDiskVolumes(){
            int size = azureDiskVolumes != null ? azureDiskVolumes.size() : 0;
io.dekorate.kubernetes.config.AzureDiskVolume[] result = new io.dekorate.kubernetes.config.AzureDiskVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.AzureDiskVolume,?> builder : azureDiskVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.AzureDiskVolume[] buildAzureDiskVolumes(){
            int size = azureDiskVolumes != null ? azureDiskVolumes.size() : 0;
io.dekorate.kubernetes.config.AzureDiskVolume[] result = new io.dekorate.kubernetes.config.AzureDiskVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.AzureDiskVolume,?> builder : azureDiskVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.AzureDiskVolume buildAzureDiskVolume(int index){
            return this.azureDiskVolumes.get(index).build();
    }

    public io.dekorate.kubernetes.config.AzureDiskVolume buildFirstAzureDiskVolume(){
            return this.azureDiskVolumes.get(0).build();
    }

    public io.dekorate.kubernetes.config.AzureDiskVolume buildLastAzureDiskVolume(){
            return this.azureDiskVolumes.get(azureDiskVolumes.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.AzureDiskVolume buildMatchingAzureDiskVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureDiskVolumeBuilder> predicate){
            for (AzureDiskVolumeBuilder item: azureDiskVolumes) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingAzureDiskVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureDiskVolumeBuilder> predicate){
            for (AzureDiskVolumeBuilder item: azureDiskVolumes) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToAzureDiskVolumes(int index,io.dekorate.kubernetes.config.AzureDiskVolume item){
            if (this.azureDiskVolumes == null) {this.azureDiskVolumes = new ArrayList<AzureDiskVolumeBuilder>();}
            io.dekorate.kubernetes.config.AzureDiskVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureDiskVolumeBuilder(item);_visitables.get("azureDiskVolumes").add(index >= 0 ? index : _visitables.get("azureDiskVolumes").size(), builder);this.azureDiskVolumes.add(index >= 0 ? index : azureDiskVolumes.size(), builder); return (A)this;
    }

    public A setToAzureDiskVolumes(int index,io.dekorate.kubernetes.config.AzureDiskVolume item){
            if (this.azureDiskVolumes == null) {this.azureDiskVolumes = new ArrayList<AzureDiskVolumeBuilder>();}
            io.dekorate.kubernetes.config.AzureDiskVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureDiskVolumeBuilder(item);
            if (index < 0 || index >= _visitables.get("azureDiskVolumes").size()) { _visitables.get("azureDiskVolumes").add(builder); } else { _visitables.get("azureDiskVolumes").set(index, builder);}
            if (index < 0 || index >= azureDiskVolumes.size()) { azureDiskVolumes.add(builder); } else { azureDiskVolumes.set(index, builder);}
             return (A)this;
    }

    public A addToAzureDiskVolumes(io.dekorate.kubernetes.config.AzureDiskVolume... items){
            if (this.azureDiskVolumes == null) {this.azureDiskVolumes = new ArrayList<AzureDiskVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.AzureDiskVolume item : items) {io.dekorate.kubernetes.config.AzureDiskVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureDiskVolumeBuilder(item);_visitables.get("azureDiskVolumes").add(builder);this.azureDiskVolumes.add(builder);} return (A)this;
    }

    public A addAllToAzureDiskVolumes(Collection<io.dekorate.kubernetes.config.AzureDiskVolume> items){
            if (this.azureDiskVolumes == null) {this.azureDiskVolumes = new ArrayList<AzureDiskVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.AzureDiskVolume item : items) {io.dekorate.kubernetes.config.AzureDiskVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureDiskVolumeBuilder(item);_visitables.get("azureDiskVolumes").add(builder);this.azureDiskVolumes.add(builder);} return (A)this;
    }

    public A removeFromAzureDiskVolumes(io.dekorate.kubernetes.config.AzureDiskVolume... items){
            for (io.dekorate.kubernetes.config.AzureDiskVolume item : items) {io.dekorate.kubernetes.config.AzureDiskVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureDiskVolumeBuilder(item);_visitables.get("azureDiskVolumes").remove(builder);if (this.azureDiskVolumes != null) {this.azureDiskVolumes.remove(builder);}} return (A)this;
    }

    public A removeAllFromAzureDiskVolumes(Collection<io.dekorate.kubernetes.config.AzureDiskVolume> items){
            for (io.dekorate.kubernetes.config.AzureDiskVolume item : items) {io.dekorate.kubernetes.config.AzureDiskVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureDiskVolumeBuilder(item);_visitables.get("azureDiskVolumes").remove(builder);if (this.azureDiskVolumes != null) {this.azureDiskVolumes.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromAzureDiskVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureDiskVolumeBuilder> predicate){
            if (azureDiskVolumes == null) return (A) this;
            final Iterator<AzureDiskVolumeBuilder> each = azureDiskVolumes.iterator();
            final List visitables = _visitables.get("azureDiskVolumes");
            while (each.hasNext()) {
              AzureDiskVolumeBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasAzureDiskVolumes(){
            return azureDiskVolumes != null && !azureDiskVolumes.isEmpty();
    }

    public BaseConfigFluent.AzureDiskVolumesNested<A> addNewAzureDiskVolume(){
            return new AzureDiskVolumesNestedImpl();
    }

    public BaseConfigFluent.AzureDiskVolumesNested<A> addNewAzureDiskVolumeLike(io.dekorate.kubernetes.config.AzureDiskVolume item){
            return new AzureDiskVolumesNestedImpl(-1, item);
    }

    public BaseConfigFluent.AzureDiskVolumesNested<A> setNewAzureDiskVolumeLike(int index,io.dekorate.kubernetes.config.AzureDiskVolume item){
            return new AzureDiskVolumesNestedImpl(index, item);
    }

    public BaseConfigFluent.AzureDiskVolumesNested<A> editAzureDiskVolume(int index){
            if (azureDiskVolumes.size() <= index) throw new RuntimeException("Can't edit azureDiskVolumes. Index exceeds size.");
            return setNewAzureDiskVolumeLike(index, buildAzureDiskVolume(index));
    }

    public BaseConfigFluent.AzureDiskVolumesNested<A> editFirstAzureDiskVolume(){
            if (azureDiskVolumes.size() == 0) throw new RuntimeException("Can't edit first azureDiskVolumes. The list is empty.");
            return setNewAzureDiskVolumeLike(0, buildAzureDiskVolume(0));
    }

    public BaseConfigFluent.AzureDiskVolumesNested<A> editLastAzureDiskVolume(){
            int index = azureDiskVolumes.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last azureDiskVolumes. The list is empty.");
            return setNewAzureDiskVolumeLike(index, buildAzureDiskVolume(index));
    }

    public BaseConfigFluent.AzureDiskVolumesNested<A> editMatchingAzureDiskVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureDiskVolumeBuilder> predicate){
            int index = -1;
            for (int i=0;i<azureDiskVolumes.size();i++) { 
            if (predicate.apply(azureDiskVolumes.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching azureDiskVolumes. No match found.");
            return setNewAzureDiskVolumeLike(index, buildAzureDiskVolume(index));
    }

    public A withAzureFileVolumes(io.dekorate.kubernetes.config.AzureFileVolume... azureFileVolumes){
            if (this.azureFileVolumes != null) {this.azureFileVolumes.clear();}
            if (azureFileVolumes != null) {for (io.dekorate.kubernetes.config.AzureFileVolume item :azureFileVolumes){ this.addToAzureFileVolumes(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildAzureFileVolumes instead.
 */
@Deprecated public io.dekorate.kubernetes.config.AzureFileVolume[] getAzureFileVolumes(){
            int size = azureFileVolumes != null ? azureFileVolumes.size() : 0;
io.dekorate.kubernetes.config.AzureFileVolume[] result = new io.dekorate.kubernetes.config.AzureFileVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.AzureFileVolume,?> builder : azureFileVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.AzureFileVolume[] buildAzureFileVolumes(){
            int size = azureFileVolumes != null ? azureFileVolumes.size() : 0;
io.dekorate.kubernetes.config.AzureFileVolume[] result = new io.dekorate.kubernetes.config.AzureFileVolume[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.AzureFileVolume,?> builder : azureFileVolumes) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.AzureFileVolume buildAzureFileVolume(int index){
            return this.azureFileVolumes.get(index).build();
    }

    public io.dekorate.kubernetes.config.AzureFileVolume buildFirstAzureFileVolume(){
            return this.azureFileVolumes.get(0).build();
    }

    public io.dekorate.kubernetes.config.AzureFileVolume buildLastAzureFileVolume(){
            return this.azureFileVolumes.get(azureFileVolumes.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.AzureFileVolume buildMatchingAzureFileVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureFileVolumeBuilder> predicate){
            for (AzureFileVolumeBuilder item: azureFileVolumes) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingAzureFileVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureFileVolumeBuilder> predicate){
            for (AzureFileVolumeBuilder item: azureFileVolumes) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToAzureFileVolumes(int index,io.dekorate.kubernetes.config.AzureFileVolume item){
            if (this.azureFileVolumes == null) {this.azureFileVolumes = new ArrayList<AzureFileVolumeBuilder>();}
            io.dekorate.kubernetes.config.AzureFileVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureFileVolumeBuilder(item);_visitables.get("azureFileVolumes").add(index >= 0 ? index : _visitables.get("azureFileVolumes").size(), builder);this.azureFileVolumes.add(index >= 0 ? index : azureFileVolumes.size(), builder); return (A)this;
    }

    public A setToAzureFileVolumes(int index,io.dekorate.kubernetes.config.AzureFileVolume item){
            if (this.azureFileVolumes == null) {this.azureFileVolumes = new ArrayList<AzureFileVolumeBuilder>();}
            io.dekorate.kubernetes.config.AzureFileVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureFileVolumeBuilder(item);
            if (index < 0 || index >= _visitables.get("azureFileVolumes").size()) { _visitables.get("azureFileVolumes").add(builder); } else { _visitables.get("azureFileVolumes").set(index, builder);}
            if (index < 0 || index >= azureFileVolumes.size()) { azureFileVolumes.add(builder); } else { azureFileVolumes.set(index, builder);}
             return (A)this;
    }

    public A addToAzureFileVolumes(io.dekorate.kubernetes.config.AzureFileVolume... items){
            if (this.azureFileVolumes == null) {this.azureFileVolumes = new ArrayList<AzureFileVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.AzureFileVolume item : items) {io.dekorate.kubernetes.config.AzureFileVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureFileVolumeBuilder(item);_visitables.get("azureFileVolumes").add(builder);this.azureFileVolumes.add(builder);} return (A)this;
    }

    public A addAllToAzureFileVolumes(Collection<io.dekorate.kubernetes.config.AzureFileVolume> items){
            if (this.azureFileVolumes == null) {this.azureFileVolumes = new ArrayList<AzureFileVolumeBuilder>();}
            for (io.dekorate.kubernetes.config.AzureFileVolume item : items) {io.dekorate.kubernetes.config.AzureFileVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureFileVolumeBuilder(item);_visitables.get("azureFileVolumes").add(builder);this.azureFileVolumes.add(builder);} return (A)this;
    }

    public A removeFromAzureFileVolumes(io.dekorate.kubernetes.config.AzureFileVolume... items){
            for (io.dekorate.kubernetes.config.AzureFileVolume item : items) {io.dekorate.kubernetes.config.AzureFileVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureFileVolumeBuilder(item);_visitables.get("azureFileVolumes").remove(builder);if (this.azureFileVolumes != null) {this.azureFileVolumes.remove(builder);}} return (A)this;
    }

    public A removeAllFromAzureFileVolumes(Collection<io.dekorate.kubernetes.config.AzureFileVolume> items){
            for (io.dekorate.kubernetes.config.AzureFileVolume item : items) {io.dekorate.kubernetes.config.AzureFileVolumeBuilder builder = new io.dekorate.kubernetes.config.AzureFileVolumeBuilder(item);_visitables.get("azureFileVolumes").remove(builder);if (this.azureFileVolumes != null) {this.azureFileVolumes.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromAzureFileVolumes(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureFileVolumeBuilder> predicate){
            if (azureFileVolumes == null) return (A) this;
            final Iterator<AzureFileVolumeBuilder> each = azureFileVolumes.iterator();
            final List visitables = _visitables.get("azureFileVolumes");
            while (each.hasNext()) {
              AzureFileVolumeBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasAzureFileVolumes(){
            return azureFileVolumes != null && !azureFileVolumes.isEmpty();
    }

    public A addNewAzureFileVolume(String volumeName,String shareName,String secretName,boolean readOnly){
            return (A)addToAzureFileVolumes(new AzureFileVolume(volumeName, shareName, secretName, readOnly));
    }

    public BaseConfigFluent.AzureFileVolumesNested<A> addNewAzureFileVolume(){
            return new AzureFileVolumesNestedImpl();
    }

    public BaseConfigFluent.AzureFileVolumesNested<A> addNewAzureFileVolumeLike(io.dekorate.kubernetes.config.AzureFileVolume item){
            return new AzureFileVolumesNestedImpl(-1, item);
    }

    public BaseConfigFluent.AzureFileVolumesNested<A> setNewAzureFileVolumeLike(int index,io.dekorate.kubernetes.config.AzureFileVolume item){
            return new AzureFileVolumesNestedImpl(index, item);
    }

    public BaseConfigFluent.AzureFileVolumesNested<A> editAzureFileVolume(int index){
            if (azureFileVolumes.size() <= index) throw new RuntimeException("Can't edit azureFileVolumes. Index exceeds size.");
            return setNewAzureFileVolumeLike(index, buildAzureFileVolume(index));
    }

    public BaseConfigFluent.AzureFileVolumesNested<A> editFirstAzureFileVolume(){
            if (azureFileVolumes.size() == 0) throw new RuntimeException("Can't edit first azureFileVolumes. The list is empty.");
            return setNewAzureFileVolumeLike(0, buildAzureFileVolume(0));
    }

    public BaseConfigFluent.AzureFileVolumesNested<A> editLastAzureFileVolume(){
            int index = azureFileVolumes.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last azureFileVolumes. The list is empty.");
            return setNewAzureFileVolumeLike(index, buildAzureFileVolume(index));
    }

    public BaseConfigFluent.AzureFileVolumesNested<A> editMatchingAzureFileVolume(io.dekorate.deps.kubernetes.api.builder.Predicate<AzureFileVolumeBuilder> predicate){
            int index = -1;
            for (int i=0;i<azureFileVolumes.size();i++) { 
            if (predicate.apply(azureFileVolumes.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching azureFileVolumes. No match found.");
            return setNewAzureFileVolumeLike(index, buildAzureFileVolume(index));
    }

    public A withMounts(io.dekorate.kubernetes.config.Mount... mounts){
            if (this.mounts != null) {this.mounts.clear();}
            if (mounts != null) {for (io.dekorate.kubernetes.config.Mount item :mounts){ this.addToMounts(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildMounts instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Mount[] getMounts(){
            int size = mounts != null ? mounts.size() : 0;
io.dekorate.kubernetes.config.Mount[] result = new io.dekorate.kubernetes.config.Mount[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Mount,?> builder : mounts) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Mount[] buildMounts(){
            int size = mounts != null ? mounts.size() : 0;
io.dekorate.kubernetes.config.Mount[] result = new io.dekorate.kubernetes.config.Mount[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Mount,?> builder : mounts) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Mount buildMount(int index){
            return this.mounts.get(index).build();
    }

    public io.dekorate.kubernetes.config.Mount buildFirstMount(){
            return this.mounts.get(0).build();
    }

    public io.dekorate.kubernetes.config.Mount buildLastMount(){
            return this.mounts.get(mounts.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.Mount buildMatchingMount(io.dekorate.deps.kubernetes.api.builder.Predicate<MountBuilder> predicate){
            for (MountBuilder item: mounts) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingMount(io.dekorate.deps.kubernetes.api.builder.Predicate<MountBuilder> predicate){
            for (MountBuilder item: mounts) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToMounts(int index,io.dekorate.kubernetes.config.Mount item){
            if (this.mounts == null) {this.mounts = new ArrayList<MountBuilder>();}
            io.dekorate.kubernetes.config.MountBuilder builder = new io.dekorate.kubernetes.config.MountBuilder(item);_visitables.get("mounts").add(index >= 0 ? index : _visitables.get("mounts").size(), builder);this.mounts.add(index >= 0 ? index : mounts.size(), builder); return (A)this;
    }

    public A setToMounts(int index,io.dekorate.kubernetes.config.Mount item){
            if (this.mounts == null) {this.mounts = new ArrayList<MountBuilder>();}
            io.dekorate.kubernetes.config.MountBuilder builder = new io.dekorate.kubernetes.config.MountBuilder(item);
            if (index < 0 || index >= _visitables.get("mounts").size()) { _visitables.get("mounts").add(builder); } else { _visitables.get("mounts").set(index, builder);}
            if (index < 0 || index >= mounts.size()) { mounts.add(builder); } else { mounts.set(index, builder);}
             return (A)this;
    }

    public A addToMounts(io.dekorate.kubernetes.config.Mount... items){
            if (this.mounts == null) {this.mounts = new ArrayList<MountBuilder>();}
            for (io.dekorate.kubernetes.config.Mount item : items) {io.dekorate.kubernetes.config.MountBuilder builder = new io.dekorate.kubernetes.config.MountBuilder(item);_visitables.get("mounts").add(builder);this.mounts.add(builder);} return (A)this;
    }

    public A addAllToMounts(Collection<io.dekorate.kubernetes.config.Mount> items){
            if (this.mounts == null) {this.mounts = new ArrayList<MountBuilder>();}
            for (io.dekorate.kubernetes.config.Mount item : items) {io.dekorate.kubernetes.config.MountBuilder builder = new io.dekorate.kubernetes.config.MountBuilder(item);_visitables.get("mounts").add(builder);this.mounts.add(builder);} return (A)this;
    }

    public A removeFromMounts(io.dekorate.kubernetes.config.Mount... items){
            for (io.dekorate.kubernetes.config.Mount item : items) {io.dekorate.kubernetes.config.MountBuilder builder = new io.dekorate.kubernetes.config.MountBuilder(item);_visitables.get("mounts").remove(builder);if (this.mounts != null) {this.mounts.remove(builder);}} return (A)this;
    }

    public A removeAllFromMounts(Collection<io.dekorate.kubernetes.config.Mount> items){
            for (io.dekorate.kubernetes.config.Mount item : items) {io.dekorate.kubernetes.config.MountBuilder builder = new io.dekorate.kubernetes.config.MountBuilder(item);_visitables.get("mounts").remove(builder);if (this.mounts != null) {this.mounts.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromMounts(io.dekorate.deps.kubernetes.api.builder.Predicate<MountBuilder> predicate){
            if (mounts == null) return (A) this;
            final Iterator<MountBuilder> each = mounts.iterator();
            final List visitables = _visitables.get("mounts");
            while (each.hasNext()) {
              MountBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasMounts(){
            return mounts != null && !mounts.isEmpty();
    }

    public A addNewMount(String name,String path,String subPath,boolean readOnly){
            return (A)addToMounts(new Mount(name, path, subPath, readOnly));
    }

    public BaseConfigFluent.MountsNested<A> addNewMount(){
            return new MountsNestedImpl();
    }

    public BaseConfigFluent.MountsNested<A> addNewMountLike(io.dekorate.kubernetes.config.Mount item){
            return new MountsNestedImpl(-1, item);
    }

    public BaseConfigFluent.MountsNested<A> setNewMountLike(int index,io.dekorate.kubernetes.config.Mount item){
            return new MountsNestedImpl(index, item);
    }

    public BaseConfigFluent.MountsNested<A> editMount(int index){
            if (mounts.size() <= index) throw new RuntimeException("Can't edit mounts. Index exceeds size.");
            return setNewMountLike(index, buildMount(index));
    }

    public BaseConfigFluent.MountsNested<A> editFirstMount(){
            if (mounts.size() == 0) throw new RuntimeException("Can't edit first mounts. The list is empty.");
            return setNewMountLike(0, buildMount(0));
    }

    public BaseConfigFluent.MountsNested<A> editLastMount(){
            int index = mounts.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last mounts. The list is empty.");
            return setNewMountLike(index, buildMount(index));
    }

    public BaseConfigFluent.MountsNested<A> editMatchingMount(io.dekorate.deps.kubernetes.api.builder.Predicate<MountBuilder> predicate){
            int index = -1;
            for (int i=0;i<mounts.size();i++) { 
            if (predicate.apply(mounts.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching mounts. No match found.");
            return setNewMountLike(index, buildMount(index));
    }

    public ImagePullPolicy getImagePullPolicy(){
            return this.imagePullPolicy;
    }

    public A withImagePullPolicy(ImagePullPolicy imagePullPolicy){
            this.imagePullPolicy=imagePullPolicy; return (A) this;
    }

    public Boolean hasImagePullPolicy(){
            return this.imagePullPolicy != null;
    }

    public A withImagePullSecrets(String... imagePullSecrets){
            if (this.imagePullSecrets != null) {this.imagePullSecrets.clear();}
            if (imagePullSecrets != null) {for (String item :imagePullSecrets){ this.addToImagePullSecrets(item);}} return (A) this;
    }

    public String[] getImagePullSecrets(){
            //This needs to work with primitives, so we use arrays.
int size = imagePullSecrets != null ? imagePullSecrets.size() : 0;
String[] result = new String[size];
if (size == 0) {
   return result;
}
int index = 0;
for (String item : imagePullSecrets) {
    result[index++]=item;
}
return result;

    }

    public A addToImagePullSecrets(int index,String item){
            if (this.imagePullSecrets == null) {this.imagePullSecrets = new ArrayList<String>();}
            this.imagePullSecrets.add(index, item);
            return (A)this;
    }

    public A setToImagePullSecrets(int index,String item){
            if (this.imagePullSecrets == null) {this.imagePullSecrets = new ArrayList<String>();}
            this.imagePullSecrets.set(index, item); return (A)this;
    }

    public A addToImagePullSecrets(String... items){
            if (this.imagePullSecrets == null) {this.imagePullSecrets = new ArrayList<String>();}
            for (String item : items) {this.imagePullSecrets.add(item);} return (A)this;
    }

    public A addAllToImagePullSecrets(Collection<String> items){
            if (this.imagePullSecrets == null) {this.imagePullSecrets = new ArrayList<String>();}
            for (String item : items) {this.imagePullSecrets.add(item);} return (A)this;
    }

    public A removeFromImagePullSecrets(String... items){
            for (String item : items) {if (this.imagePullSecrets!= null){ this.imagePullSecrets.remove(item);}} return (A)this;
    }

    public A removeAllFromImagePullSecrets(Collection<String> items){
            for (String item : items) {if (this.imagePullSecrets!= null){ this.imagePullSecrets.remove(item);}} return (A)this;
    }

    public Boolean hasImagePullSecrets(){
            return imagePullSecrets != null && !imagePullSecrets.isEmpty();
    }

    public A addNewImagePullSecret(String arg1){
            return (A)addToImagePullSecrets(new String(arg1));
    }

    public A addNewImagePullSecret(StringBuilder arg1){
            return (A)addToImagePullSecrets(new String(arg1));
    }

    public A addNewImagePullSecret(StringBuffer arg1){
            return (A)addToImagePullSecrets(new String(arg1));
    }

    
/**
 * This method has been deprecated, please use method buildLivenessProbe instead.
 * @return The buildable object.
 */
@Deprecated public io.dekorate.kubernetes.config.Probe getLivenessProbe(){
            return this.livenessProbe!=null?this.livenessProbe.build():null;
    }

    public io.dekorate.kubernetes.config.Probe buildLivenessProbe(){
            return this.livenessProbe!=null?this.livenessProbe.build():null;
    }

    public A withLivenessProbe(io.dekorate.kubernetes.config.Probe livenessProbe){
            _visitables.get("livenessProbe").remove(this.livenessProbe);
            if (livenessProbe!=null){ this.livenessProbe= new ProbeBuilder(livenessProbe); _visitables.get("livenessProbe").add(this.livenessProbe);} return (A) this;
    }

    public Boolean hasLivenessProbe(){
            return this.livenessProbe != null;
    }

    public BaseConfigFluent.LivenessProbeNested<A> withNewLivenessProbe(){
            return new LivenessProbeNestedImpl();
    }

    public BaseConfigFluent.LivenessProbeNested<A> withNewLivenessProbeLike(io.dekorate.kubernetes.config.Probe item){
            return new LivenessProbeNestedImpl(item);
    }

    public BaseConfigFluent.LivenessProbeNested<A> editLivenessProbe(){
            return withNewLivenessProbeLike(getLivenessProbe());
    }

    public BaseConfigFluent.LivenessProbeNested<A> editOrNewLivenessProbe(){
            return withNewLivenessProbeLike(getLivenessProbe() != null ? getLivenessProbe(): new ProbeBuilder().build());
    }

    public BaseConfigFluent.LivenessProbeNested<A> editOrNewLivenessProbeLike(io.dekorate.kubernetes.config.Probe item){
            return withNewLivenessProbeLike(getLivenessProbe() != null ? getLivenessProbe(): item);
    }

    
/**
 * This method has been deprecated, please use method buildReadinessProbe instead.
 * @return The buildable object.
 */
@Deprecated public io.dekorate.kubernetes.config.Probe getReadinessProbe(){
            return this.readinessProbe!=null?this.readinessProbe.build():null;
    }

    public io.dekorate.kubernetes.config.Probe buildReadinessProbe(){
            return this.readinessProbe!=null?this.readinessProbe.build():null;
    }

    public A withReadinessProbe(io.dekorate.kubernetes.config.Probe readinessProbe){
            _visitables.get("readinessProbe").remove(this.readinessProbe);
            if (readinessProbe!=null){ this.readinessProbe= new ProbeBuilder(readinessProbe); _visitables.get("readinessProbe").add(this.readinessProbe);} return (A) this;
    }

    public Boolean hasReadinessProbe(){
            return this.readinessProbe != null;
    }

    public BaseConfigFluent.ReadinessProbeNested<A> withNewReadinessProbe(){
            return new ReadinessProbeNestedImpl();
    }

    public BaseConfigFluent.ReadinessProbeNested<A> withNewReadinessProbeLike(io.dekorate.kubernetes.config.Probe item){
            return new ReadinessProbeNestedImpl(item);
    }

    public BaseConfigFluent.ReadinessProbeNested<A> editReadinessProbe(){
            return withNewReadinessProbeLike(getReadinessProbe());
    }

    public BaseConfigFluent.ReadinessProbeNested<A> editOrNewReadinessProbe(){
            return withNewReadinessProbeLike(getReadinessProbe() != null ? getReadinessProbe(): new ProbeBuilder().build());
    }

    public BaseConfigFluent.ReadinessProbeNested<A> editOrNewReadinessProbeLike(io.dekorate.kubernetes.config.Probe item){
            return withNewReadinessProbeLike(getReadinessProbe() != null ? getReadinessProbe(): item);
    }

    public A withSidecars(io.dekorate.kubernetes.config.Container... sidecars){
            if (this.sidecars != null) {this.sidecars.clear();}
            if (sidecars != null) {for (io.dekorate.kubernetes.config.Container item :sidecars){ this.addToSidecars(item);}} return (A) this;
    }

    
/**
 * This method has been deprecated, please use method buildSidecars instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Container[] getSidecars(){
            int size = sidecars != null ? sidecars.size() : 0;
io.dekorate.kubernetes.config.Container[] result = new io.dekorate.kubernetes.config.Container[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Container,?> builder : sidecars) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Container[] buildSidecars(){
            int size = sidecars != null ? sidecars.size() : 0;
io.dekorate.kubernetes.config.Container[] result = new io.dekorate.kubernetes.config.Container[size];
if (size == 0) {
   return result;
}
int index = 0;
for (VisitableBuilder<? extends io.dekorate.kubernetes.config.Container,?> builder : sidecars) {
    result[index++]=builder.build();
}
return result;

    }

    public io.dekorate.kubernetes.config.Container buildSidecar(int index){
            return this.sidecars.get(index).build();
    }

    public io.dekorate.kubernetes.config.Container buildFirstSidecar(){
            return this.sidecars.get(0).build();
    }

    public io.dekorate.kubernetes.config.Container buildLastSidecar(){
            return this.sidecars.get(sidecars.size() - 1).build();
    }

    public io.dekorate.kubernetes.config.Container buildMatchingSidecar(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate){
            for (ContainerBuilder item: sidecars) { if(predicate.apply(item)){ return item.build();} } return null;
    }

    public Boolean hasMatchingSidecar(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate){
            for (ContainerBuilder item: sidecars) { if(predicate.apply(item)){ return true;} } return false;
    }

    public A addToSidecars(int index,io.dekorate.kubernetes.config.Container item){
            if (this.sidecars == null) {this.sidecars = new ArrayList<ContainerBuilder>();}
            io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);_visitables.get("sidecars").add(index >= 0 ? index : _visitables.get("sidecars").size(), builder);this.sidecars.add(index >= 0 ? index : sidecars.size(), builder); return (A)this;
    }

    public A setToSidecars(int index,io.dekorate.kubernetes.config.Container item){
            if (this.sidecars == null) {this.sidecars = new ArrayList<ContainerBuilder>();}
            io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);
            if (index < 0 || index >= _visitables.get("sidecars").size()) { _visitables.get("sidecars").add(builder); } else { _visitables.get("sidecars").set(index, builder);}
            if (index < 0 || index >= sidecars.size()) { sidecars.add(builder); } else { sidecars.set(index, builder);}
             return (A)this;
    }

    public A addToSidecars(io.dekorate.kubernetes.config.Container... items){
            if (this.sidecars == null) {this.sidecars = new ArrayList<ContainerBuilder>();}
            for (io.dekorate.kubernetes.config.Container item : items) {io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);_visitables.get("sidecars").add(builder);this.sidecars.add(builder);} return (A)this;
    }

    public A addAllToSidecars(Collection<io.dekorate.kubernetes.config.Container> items){
            if (this.sidecars == null) {this.sidecars = new ArrayList<ContainerBuilder>();}
            for (io.dekorate.kubernetes.config.Container item : items) {io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);_visitables.get("sidecars").add(builder);this.sidecars.add(builder);} return (A)this;
    }

    public A removeFromSidecars(io.dekorate.kubernetes.config.Container... items){
            for (io.dekorate.kubernetes.config.Container item : items) {io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);_visitables.get("sidecars").remove(builder);if (this.sidecars != null) {this.sidecars.remove(builder);}} return (A)this;
    }

    public A removeAllFromSidecars(Collection<io.dekorate.kubernetes.config.Container> items){
            for (io.dekorate.kubernetes.config.Container item : items) {io.dekorate.kubernetes.config.ContainerBuilder builder = new io.dekorate.kubernetes.config.ContainerBuilder(item);_visitables.get("sidecars").remove(builder);if (this.sidecars != null) {this.sidecars.remove(builder);}} return (A)this;
    }

    public A removeMatchingFromSidecars(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate){
            if (sidecars == null) return (A) this;
            final Iterator<ContainerBuilder> each = sidecars.iterator();
            final List visitables = _visitables.get("sidecars");
            while (each.hasNext()) {
              ContainerBuilder builder = each.next();
              if (predicate.apply(builder)) {
                visitables.remove(builder);
                each.remove();
              }
            }
            return (A)this;
    }

    public Boolean hasSidecars(){
            return sidecars != null && !sidecars.isEmpty();
    }

    public BaseConfigFluent.SidecarsNested<A> addNewSidecar(){
            return new SidecarsNestedImpl();
    }

    public BaseConfigFluent.SidecarsNested<A> addNewSidecarLike(io.dekorate.kubernetes.config.Container item){
            return new SidecarsNestedImpl(-1, item);
    }

    public BaseConfigFluent.SidecarsNested<A> setNewSidecarLike(int index,io.dekorate.kubernetes.config.Container item){
            return new SidecarsNestedImpl(index, item);
    }

    public BaseConfigFluent.SidecarsNested<A> editSidecar(int index){
            if (sidecars.size() <= index) throw new RuntimeException("Can't edit sidecars. Index exceeds size.");
            return setNewSidecarLike(index, buildSidecar(index));
    }

    public BaseConfigFluent.SidecarsNested<A> editFirstSidecar(){
            if (sidecars.size() == 0) throw new RuntimeException("Can't edit first sidecars. The list is empty.");
            return setNewSidecarLike(0, buildSidecar(0));
    }

    public BaseConfigFluent.SidecarsNested<A> editLastSidecar(){
            int index = sidecars.size() - 1;
            if (index < 0) throw new RuntimeException("Can't edit last sidecars. The list is empty.");
            return setNewSidecarLike(index, buildSidecar(index));
    }

    public BaseConfigFluent.SidecarsNested<A> editMatchingSidecar(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate){
            int index = -1;
            for (int i=0;i<sidecars.size();i++) { 
            if (predicate.apply(sidecars.get(i))) {index = i; break;}
            } 
            if (index < 0) throw new RuntimeException("Can't edit matching sidecars. No match found.");
            return setNewSidecarLike(index, buildSidecar(index));
    }

    public boolean isExpose(){
            return this.expose;
    }

    public A withExpose(boolean expose){
            this.expose=expose; return (A) this;
    }

    public Boolean hasExpose(){
            return true;
    }

    public boolean isAutoDeployEnabled(){
            return this.autoDeployEnabled;
    }

    public A withAutoDeployEnabled(boolean autoDeployEnabled){
            this.autoDeployEnabled=autoDeployEnabled; return (A) this;
    }

    public Boolean hasAutoDeployEnabled(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            BaseConfigFluentImpl that = (BaseConfigFluentImpl) o;
            if (initContainers != null ? !initContainers.equals(that.initContainers) :that.initContainers != null) return false;
            if (labels != null ? !labels.equals(that.labels) :that.labels != null) return false;
            if (annotations != null ? !annotations.equals(that.annotations) :that.annotations != null) return false;
            if (envVars != null ? !envVars.equals(that.envVars) :that.envVars != null) return false;
            if (workingDir != null ? !workingDir.equals(that.workingDir) :that.workingDir != null) return false;
            if (command != null ? !command.equals(that.command) :that.command != null) return false;
            if (arguments != null ? !arguments.equals(that.arguments) :that.arguments != null) return false;
            if (replicas != that.replicas) return false;
            if (serviceAccount != null ? !serviceAccount.equals(that.serviceAccount) :that.serviceAccount != null) return false;
            if (host != null ? !host.equals(that.host) :that.host != null) return false;
            if (ports != null ? !ports.equals(that.ports) :that.ports != null) return false;
            if (serviceType != null ? !serviceType.equals(that.serviceType) :that.serviceType != null) return false;
            if (pvcVolumes != null ? !pvcVolumes.equals(that.pvcVolumes) :that.pvcVolumes != null) return false;
            if (secretVolumes != null ? !secretVolumes.equals(that.secretVolumes) :that.secretVolumes != null) return false;
            if (configMapVolumes != null ? !configMapVolumes.equals(that.configMapVolumes) :that.configMapVolumes != null) return false;
            if (gitRepoVolumes != null ? !gitRepoVolumes.equals(that.gitRepoVolumes) :that.gitRepoVolumes != null) return false;
            if (awsElasticBlockStoreVolumes != null ? !awsElasticBlockStoreVolumes.equals(that.awsElasticBlockStoreVolumes) :that.awsElasticBlockStoreVolumes != null) return false;
            if (azureDiskVolumes != null ? !azureDiskVolumes.equals(that.azureDiskVolumes) :that.azureDiskVolumes != null) return false;
            if (azureFileVolumes != null ? !azureFileVolumes.equals(that.azureFileVolumes) :that.azureFileVolumes != null) return false;
            if (mounts != null ? !mounts.equals(that.mounts) :that.mounts != null) return false;
            if (imagePullPolicy != null ? !imagePullPolicy.equals(that.imagePullPolicy) :that.imagePullPolicy != null) return false;
            if (imagePullSecrets != null ? !imagePullSecrets.equals(that.imagePullSecrets) :that.imagePullSecrets != null) return false;
            if (livenessProbe != null ? !livenessProbe.equals(that.livenessProbe) :that.livenessProbe != null) return false;
            if (readinessProbe != null ? !readinessProbe.equals(that.readinessProbe) :that.readinessProbe != null) return false;
            if (sidecars != null ? !sidecars.equals(that.sidecars) :that.sidecars != null) return false;
            if (expose != that.expose) return false;
            if (autoDeployEnabled != that.autoDeployEnabled) return false;
            return true;
    }


    public class InitContainersNestedImpl<N> extends ContainerFluentImpl<BaseConfigFluent.InitContainersNested<N>> implements BaseConfigFluent.InitContainersNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final ContainerBuilder builder;
        private final int index;
    
            InitContainersNestedImpl(int index,io.dekorate.kubernetes.config.Container item){
                    this.index = index;
                    this.builder = new ContainerBuilder(this, item);
            }
            InitContainersNestedImpl(){
                    this.index = -1;
                    this.builder = new ContainerBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToInitContainers(index, builder.build());
    }
    public N endInitContainer(){
            return and();
    }

}
    public class LabelsNestedImpl<N> extends LabelFluentImpl<BaseConfigFluent.LabelsNested<N>> implements BaseConfigFluent.LabelsNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final LabelBuilder builder;
        private final int index;
    
            LabelsNestedImpl(int index,io.dekorate.kubernetes.config.Label item){
                    this.index = index;
                    this.builder = new LabelBuilder(this, item);
            }
            LabelsNestedImpl(){
                    this.index = -1;
                    this.builder = new LabelBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToLabels(index, builder.build());
    }
    public N endLabel(){
            return and();
    }

}
    public class AnnotationsNestedImpl<N> extends AnnotationFluentImpl<BaseConfigFluent.AnnotationsNested<N>> implements BaseConfigFluent.AnnotationsNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final AnnotationBuilder builder;
        private final int index;
    
            AnnotationsNestedImpl(int index,io.dekorate.kubernetes.config.Annotation item){
                    this.index = index;
                    this.builder = new AnnotationBuilder(this, item);
            }
            AnnotationsNestedImpl(){
                    this.index = -1;
                    this.builder = new AnnotationBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToAnnotations(index, builder.build());
    }
    public N endAnnotation(){
            return and();
    }

}
    public class EnvVarsNestedImpl<N> extends EnvFluentImpl<BaseConfigFluent.EnvVarsNested<N>> implements BaseConfigFluent.EnvVarsNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final EnvBuilder builder;
        private final int index;
    
            EnvVarsNestedImpl(int index,io.dekorate.kubernetes.config.Env item){
                    this.index = index;
                    this.builder = new EnvBuilder(this, item);
            }
            EnvVarsNestedImpl(){
                    this.index = -1;
                    this.builder = new EnvBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToEnvVars(index, builder.build());
    }
    public N endEnvVar(){
            return and();
    }

}
    public class PortsNestedImpl<N> extends PortFluentImpl<BaseConfigFluent.PortsNested<N>> implements BaseConfigFluent.PortsNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final PortBuilder builder;
        private final int index;
    
            PortsNestedImpl(int index,io.dekorate.kubernetes.config.Port item){
                    this.index = index;
                    this.builder = new PortBuilder(this, item);
            }
            PortsNestedImpl(){
                    this.index = -1;
                    this.builder = new PortBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToPorts(index, builder.build());
    }
    public N endPort(){
            return and();
    }

}
    public class PvcVolumesNestedImpl<N> extends PersistentVolumeClaimVolumeFluentImpl<BaseConfigFluent.PvcVolumesNested<N>> implements BaseConfigFluent.PvcVolumesNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final PersistentVolumeClaimVolumeBuilder builder;
        private final int index;
    
            PvcVolumesNestedImpl(int index,io.dekorate.kubernetes.config.PersistentVolumeClaimVolume item){
                    this.index = index;
                    this.builder = new PersistentVolumeClaimVolumeBuilder(this, item);
            }
            PvcVolumesNestedImpl(){
                    this.index = -1;
                    this.builder = new PersistentVolumeClaimVolumeBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToPvcVolumes(index, builder.build());
    }
    public N endPvcVolume(){
            return and();
    }

}
    public class SecretVolumesNestedImpl<N> extends SecretVolumeFluentImpl<BaseConfigFluent.SecretVolumesNested<N>> implements BaseConfigFluent.SecretVolumesNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final SecretVolumeBuilder builder;
        private final int index;
    
            SecretVolumesNestedImpl(int index,io.dekorate.kubernetes.config.SecretVolume item){
                    this.index = index;
                    this.builder = new SecretVolumeBuilder(this, item);
            }
            SecretVolumesNestedImpl(){
                    this.index = -1;
                    this.builder = new SecretVolumeBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToSecretVolumes(index, builder.build());
    }
    public N endSecretVolume(){
            return and();
    }

}
    public class ConfigMapVolumesNestedImpl<N> extends ConfigMapVolumeFluentImpl<BaseConfigFluent.ConfigMapVolumesNested<N>> implements BaseConfigFluent.ConfigMapVolumesNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final ConfigMapVolumeBuilder builder;
        private final int index;
    
            ConfigMapVolumesNestedImpl(int index,io.dekorate.kubernetes.config.ConfigMapVolume item){
                    this.index = index;
                    this.builder = new ConfigMapVolumeBuilder(this, item);
            }
            ConfigMapVolumesNestedImpl(){
                    this.index = -1;
                    this.builder = new ConfigMapVolumeBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToConfigMapVolumes(index, builder.build());
    }
    public N endConfigMapVolume(){
            return and();
    }

}
    public class GitRepoVolumesNestedImpl<N> extends GitRepoVolumeFluentImpl<BaseConfigFluent.GitRepoVolumesNested<N>> implements BaseConfigFluent.GitRepoVolumesNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final GitRepoVolumeBuilder builder;
        private final int index;
    
            GitRepoVolumesNestedImpl(int index,io.dekorate.kubernetes.config.GitRepoVolume item){
                    this.index = index;
                    this.builder = new GitRepoVolumeBuilder(this, item);
            }
            GitRepoVolumesNestedImpl(){
                    this.index = -1;
                    this.builder = new GitRepoVolumeBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToGitRepoVolumes(index, builder.build());
    }
    public N endGitRepoVolume(){
            return and();
    }

}
    public class AwsElasticBlockStoreVolumesNestedImpl<N> extends AwsElasticBlockStoreVolumeFluentImpl<BaseConfigFluent.AwsElasticBlockStoreVolumesNested<N>> implements BaseConfigFluent.AwsElasticBlockStoreVolumesNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final AwsElasticBlockStoreVolumeBuilder builder;
        private final int index;
    
            AwsElasticBlockStoreVolumesNestedImpl(int index,io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume item){
                    this.index = index;
                    this.builder = new AwsElasticBlockStoreVolumeBuilder(this, item);
            }
            AwsElasticBlockStoreVolumesNestedImpl(){
                    this.index = -1;
                    this.builder = new AwsElasticBlockStoreVolumeBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToAwsElasticBlockStoreVolumes(index, builder.build());
    }
    public N endAwsElasticBlockStoreVolume(){
            return and();
    }

}
    public class AzureDiskVolumesNestedImpl<N> extends AzureDiskVolumeFluentImpl<BaseConfigFluent.AzureDiskVolumesNested<N>> implements BaseConfigFluent.AzureDiskVolumesNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final AzureDiskVolumeBuilder builder;
        private final int index;
    
            AzureDiskVolumesNestedImpl(int index,io.dekorate.kubernetes.config.AzureDiskVolume item){
                    this.index = index;
                    this.builder = new AzureDiskVolumeBuilder(this, item);
            }
            AzureDiskVolumesNestedImpl(){
                    this.index = -1;
                    this.builder = new AzureDiskVolumeBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToAzureDiskVolumes(index, builder.build());
    }
    public N endAzureDiskVolume(){
            return and();
    }

}
    public class AzureFileVolumesNestedImpl<N> extends AzureFileVolumeFluentImpl<BaseConfigFluent.AzureFileVolumesNested<N>> implements BaseConfigFluent.AzureFileVolumesNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final AzureFileVolumeBuilder builder;
        private final int index;
    
            AzureFileVolumesNestedImpl(int index,io.dekorate.kubernetes.config.AzureFileVolume item){
                    this.index = index;
                    this.builder = new AzureFileVolumeBuilder(this, item);
            }
            AzureFileVolumesNestedImpl(){
                    this.index = -1;
                    this.builder = new AzureFileVolumeBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToAzureFileVolumes(index, builder.build());
    }
    public N endAzureFileVolume(){
            return and();
    }

}
    public class MountsNestedImpl<N> extends MountFluentImpl<BaseConfigFluent.MountsNested<N>> implements BaseConfigFluent.MountsNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final MountBuilder builder;
        private final int index;
    
            MountsNestedImpl(int index,io.dekorate.kubernetes.config.Mount item){
                    this.index = index;
                    this.builder = new MountBuilder(this, item);
            }
            MountsNestedImpl(){
                    this.index = -1;
                    this.builder = new MountBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToMounts(index, builder.build());
    }
    public N endMount(){
            return and();
    }

}
    public class LivenessProbeNestedImpl<N> extends ProbeFluentImpl<BaseConfigFluent.LivenessProbeNested<N>> implements BaseConfigFluent.LivenessProbeNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final ProbeBuilder builder;
    
            LivenessProbeNestedImpl(io.dekorate.kubernetes.config.Probe item){
                    this.builder = new ProbeBuilder(this, item);
            }
            LivenessProbeNestedImpl(){
                    this.builder = new ProbeBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.withLivenessProbe(builder.build());
    }
    public N endLivenessProbe(){
            return and();
    }

}
    public class ReadinessProbeNestedImpl<N> extends ProbeFluentImpl<BaseConfigFluent.ReadinessProbeNested<N>> implements BaseConfigFluent.ReadinessProbeNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final ProbeBuilder builder;
    
            ReadinessProbeNestedImpl(io.dekorate.kubernetes.config.Probe item){
                    this.builder = new ProbeBuilder(this, item);
            }
            ReadinessProbeNestedImpl(){
                    this.builder = new ProbeBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.withReadinessProbe(builder.build());
    }
    public N endReadinessProbe(){
            return and();
    }

}
    public class SidecarsNestedImpl<N> extends ContainerFluentImpl<BaseConfigFluent.SidecarsNested<N>> implements BaseConfigFluent.SidecarsNested<N>,io.dekorate.deps.kubernetes.api.builder.Nested<N>{

            private final ContainerBuilder builder;
        private final int index;
    
            SidecarsNestedImpl(int index,io.dekorate.kubernetes.config.Container item){
                    this.index = index;
                    this.builder = new ContainerBuilder(this, item);
            }
            SidecarsNestedImpl(){
                    this.index = -1;
                    this.builder = new ContainerBuilder(this);
            }
    
    public N and(){
            return (N) BaseConfigFluentImpl.this.setToSidecars(index, builder.build());
    }
    public N endSidecar(){
            return and();
    }

}


}
