package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class ConfigMapVolumeBuilder extends ConfigMapVolumeFluentImpl<ConfigMapVolumeBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.ConfigMapVolume,ConfigMapVolumeBuilder>{

    ConfigMapVolumeFluent<?> fluent;
    Boolean validationEnabled;

    public ConfigMapVolumeBuilder(){
            this(true);
    }
    public ConfigMapVolumeBuilder(Boolean validationEnabled){
            this(new ConfigMapVolume(), validationEnabled);
    }
    public ConfigMapVolumeBuilder(ConfigMapVolumeFluent<?> fluent){
            this(fluent, true);
    }
    public ConfigMapVolumeBuilder(ConfigMapVolumeFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new ConfigMapVolume(), validationEnabled);
    }
    public ConfigMapVolumeBuilder(ConfigMapVolumeFluent<?> fluent,io.dekorate.kubernetes.config.ConfigMapVolume instance){
            this(fluent, instance, true);
    }
    public ConfigMapVolumeBuilder(ConfigMapVolumeFluent<?> fluent,io.dekorate.kubernetes.config.ConfigMapVolume instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withVolumeName(instance.getVolumeName()); 
            fluent.withConfigMapName(instance.getConfigMapName()); 
            fluent.withDefaultMode(instance.getDefaultMode()); 
            fluent.withOptional(instance.isOptional()); 
            this.validationEnabled = validationEnabled; 
    }
    public ConfigMapVolumeBuilder(io.dekorate.kubernetes.config.ConfigMapVolume instance){
            this(instance,true);
    }
    public ConfigMapVolumeBuilder(io.dekorate.kubernetes.config.ConfigMapVolume instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withVolumeName(instance.getVolumeName()); 
            this.withConfigMapName(instance.getConfigMapName()); 
            this.withDefaultMode(instance.getDefaultMode()); 
            this.withOptional(instance.isOptional()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableConfigMapVolume build(){
            EditableConfigMapVolume buildable = new EditableConfigMapVolume(fluent.getVolumeName(),fluent.getConfigMapName(),fluent.getDefaultMode(),fluent.isOptional());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ConfigMapVolumeBuilder that = (ConfigMapVolumeBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
