package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class ConfigurationBuilder extends ConfigurationFluentImpl<ConfigurationBuilder> implements VisitableBuilder<Configuration,ConfigurationBuilder>{

    ConfigurationFluent<?> fluent;
    Boolean validationEnabled;

    public ConfigurationBuilder(){
            this(true);
    }
    public ConfigurationBuilder(Boolean validationEnabled){
            this(new Configuration(), validationEnabled);
    }
    public ConfigurationBuilder(ConfigurationFluent<?> fluent){
            this(fluent, true);
    }
    public ConfigurationBuilder(ConfigurationFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Configuration(), validationEnabled);
    }
    public ConfigurationBuilder(ConfigurationFluent<?> fluent,Configuration instance){
            this(fluent, instance, true);
    }
    public ConfigurationBuilder(ConfigurationFluent<?> fluent,Configuration instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withProject(instance.getProject()); 
            fluent.withAttributes(instance.getAttributes()); 
            this.validationEnabled = validationEnabled; 
    }
    public ConfigurationBuilder(Configuration instance){
            this(instance,true);
    }
    public ConfigurationBuilder(Configuration instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withProject(instance.getProject()); 
            this.withAttributes(instance.getAttributes()); 
            this.validationEnabled = validationEnabled; 
    }

    public io.dekorate.kubernetes.config.EditableConfiguration build(){
            EditableConfiguration buildable = new EditableConfiguration(fluent.getProject(),fluent.getAttributes());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ConfigurationBuilder that = (ConfigurationBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
