package io.dekorate.kubernetes.config;

import io.dekorate.project.Project;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import java.lang.Object;
import java.lang.Boolean;
import java.util.Map;
import java.util.LinkedHashMap;

public interface ConfigurationFluent<A extends ConfigurationFluent<A>> extends Fluent<A>{


    public Project getProject();
    public A withProject(Project project);
    public Boolean hasProject();
    public A addToAttributes(ConfigKey key,Object value);
    public A addToAttributes(Map<ConfigKey,Object> map);
    public A removeFromAttributes(ConfigKey key);
    public A removeFromAttributes(Map<ConfigKey,Object> map);
    public Map<ConfigKey,Object> getAttributes();
    public A withAttributes(Map<ConfigKey,Object> attributes);
    public Boolean hasAttributes();



}
