package io.dekorate.kubernetes.config;

import io.dekorate.project.Project;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.Boolean;
import java.util.Map;
import java.util.LinkedHashMap;

public class ConfigurationFluentImpl<A extends ConfigurationFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements ConfigurationFluent<A>{

    private Project project;
    private Map<ConfigKey,Object> attributes;

    public ConfigurationFluentImpl(){
    }
    public ConfigurationFluentImpl(Configuration instance){
            this.withProject(instance.getProject()); 
            this.withAttributes(instance.getAttributes()); 
    }

    public Project getProject(){
            return this.project;
    }

    public A withProject(Project project){
            this.project=project; return (A) this;
    }

    public Boolean hasProject(){
            return this.project != null;
    }

    public A addToAttributes(ConfigKey key,Object value){
            if(this.attributes == null && key != null && value != null) { this.attributes = new LinkedHashMap<ConfigKey,Object>(); }
            if(key != null && value != null) {this.attributes.put(key, value);} return (A)this;
    }

    public A addToAttributes(Map<ConfigKey,Object> map){
            if(this.attributes == null && map != null) { this.attributes = new LinkedHashMap<ConfigKey,Object>(); }
            if(map != null) { this.attributes.putAll(map);} return (A)this;
    }

    public A removeFromAttributes(ConfigKey key){
            if(this.attributes == null) { return (A) this; }
            if(key != null && this.attributes != null) {this.attributes.remove(key);} return (A)this;
    }

    public A removeFromAttributes(Map<ConfigKey,Object> map){
            if(this.attributes == null) { return (A) this; }
            if(map != null) { for(Object key : map.keySet()) {if (this.attributes != null){this.attributes.remove(key);}}} return (A)this;
    }

    public Map<ConfigKey,Object> getAttributes(){
            return this.attributes;
    }

    public A withAttributes(Map<ConfigKey,Object> attributes){
            if (attributes == null) { this.attributes =  null;} else {this.attributes = new LinkedHashMap<ConfigKey,Object>(attributes);} return (A) this;
    }

    public Boolean hasAttributes(){
            return this.attributes != null;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            ConfigurationFluentImpl that = (ConfigurationFluentImpl) o;
            if (project != null ? !project.equals(that.project) :that.project != null) return false;
            if (attributes != null ? !attributes.equals(that.attributes) :that.attributes != null) return false;
            return true;
    }




}
