package io.dekorate.kubernetes.config;

import io.dekorate.kubernetes.annotation.ImagePullPolicy;
import java.lang.String;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class Container{

    private String image;
    private String name = "";
    private io.dekorate.kubernetes.config.Env[] envVars = new io.dekorate.kubernetes.config.Env[0];
    private String workingDir = "";
    private String[] command = new java.lang.String[0];
    private String[] arguments = new java.lang.String[0];
    private io.dekorate.kubernetes.config.Port[] ports = new io.dekorate.kubernetes.config.Port[0];
    private io.dekorate.kubernetes.config.Mount[] mounts = new io.dekorate.kubernetes.config.Mount[0];
    private ImagePullPolicy imagePullPolicy = io.dekorate.kubernetes.annotation.ImagePullPolicy.IfNotPresent;
    private io.dekorate.kubernetes.config.Probe livenessProbe = null;
    private io.dekorate.kubernetes.config.Probe readinessProbe = null;

    public Container(){
    }
    public Container(String image,String name,io.dekorate.kubernetes.config.Env[] envVars,String workingDir,String[] command,String[] arguments,io.dekorate.kubernetes.config.Port[] ports,io.dekorate.kubernetes.config.Mount[] mounts,ImagePullPolicy imagePullPolicy,io.dekorate.kubernetes.config.Probe livenessProbe,io.dekorate.kubernetes.config.Probe readinessProbe){
            this.image = image;
            this.name = name != null ? name : "";
            this.envVars = envVars != null ? envVars : new io.dekorate.kubernetes.config.Env[0];
            this.workingDir = workingDir != null ? workingDir : "";
            this.command = command != null ? command : new java.lang.String[0];
            this.arguments = arguments != null ? arguments : new java.lang.String[0];
            this.ports = ports != null ? ports : new io.dekorate.kubernetes.config.Port[0];
            this.mounts = mounts != null ? mounts : new io.dekorate.kubernetes.config.Mount[0];
            this.imagePullPolicy = imagePullPolicy != null ? imagePullPolicy : io.dekorate.kubernetes.annotation.ImagePullPolicy.IfNotPresent;
            this.livenessProbe = livenessProbe != null ? livenessProbe : null;
            this.readinessProbe = readinessProbe != null ? readinessProbe : null;
    }

    public String getImage(){
            return this.image;
    }

    public String getName(){
            return this.name;
    }

    public io.dekorate.kubernetes.config.Env[] getEnvVars(){
            return this.envVars;
    }

    public String getWorkingDir(){
            return this.workingDir;
    }

    public String[] getCommand(){
            return this.command;
    }

    public String[] getArguments(){
            return this.arguments;
    }

    public io.dekorate.kubernetes.config.Port[] getPorts(){
            return this.ports;
    }

    public io.dekorate.kubernetes.config.Mount[] getMounts(){
            return this.mounts;
    }

    public ImagePullPolicy getImagePullPolicy(){
            return this.imagePullPolicy;
    }

    public io.dekorate.kubernetes.config.Probe getLivenessProbe(){
            return this.livenessProbe;
    }

    public io.dekorate.kubernetes.config.Probe getReadinessProbe(){
            return this.readinessProbe;
    }




}
