package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class ContainerBuilder extends ContainerFluentImpl<ContainerBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.Container,ContainerBuilder>{

    ContainerFluent<?> fluent;
    Boolean validationEnabled;

    public ContainerBuilder(){
            this(true);
    }
    public ContainerBuilder(Boolean validationEnabled){
            this(new Container(), validationEnabled);
    }
    public ContainerBuilder(ContainerFluent<?> fluent){
            this(fluent, true);
    }
    public ContainerBuilder(ContainerFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Container(), validationEnabled);
    }
    public ContainerBuilder(ContainerFluent<?> fluent,io.dekorate.kubernetes.config.Container instance){
            this(fluent, instance, true);
    }
    public ContainerBuilder(ContainerFluent<?> fluent,io.dekorate.kubernetes.config.Container instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withImage(instance.getImage()); 
            fluent.withName(instance.getName()); 
            fluent.withEnvVars(instance.getEnvVars()); 
            fluent.withWorkingDir(instance.getWorkingDir()); 
            fluent.withCommand(instance.getCommand()); 
            fluent.withArguments(instance.getArguments()); 
            fluent.withPorts(instance.getPorts()); 
            fluent.withMounts(instance.getMounts()); 
            fluent.withImagePullPolicy(instance.getImagePullPolicy()); 
            fluent.withLivenessProbe(instance.getLivenessProbe()); 
            fluent.withReadinessProbe(instance.getReadinessProbe()); 
            this.validationEnabled = validationEnabled; 
    }
    public ContainerBuilder(io.dekorate.kubernetes.config.Container instance){
            this(instance,true);
    }
    public ContainerBuilder(io.dekorate.kubernetes.config.Container instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withImage(instance.getImage()); 
            this.withName(instance.getName()); 
            this.withEnvVars(instance.getEnvVars()); 
            this.withWorkingDir(instance.getWorkingDir()); 
            this.withCommand(instance.getCommand()); 
            this.withArguments(instance.getArguments()); 
            this.withPorts(instance.getPorts()); 
            this.withMounts(instance.getMounts()); 
            this.withImagePullPolicy(instance.getImagePullPolicy()); 
            this.withLivenessProbe(instance.getLivenessProbe()); 
            this.withReadinessProbe(instance.getReadinessProbe()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableContainer build(){
            EditableContainer buildable = new EditableContainer(fluent.getImage(),fluent.getName(),fluent.getEnvVars(),fluent.getWorkingDir(),fluent.getCommand(),fluent.getArguments(),fluent.getPorts(),fluent.getMounts(),fluent.getImagePullPolicy(),fluent.getLivenessProbe(),fluent.getReadinessProbe());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ContainerBuilder that = (ContainerBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
