package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class GitRepoVolumeBuilder extends GitRepoVolumeFluentImpl<GitRepoVolumeBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.GitRepoVolume,GitRepoVolumeBuilder>{

    GitRepoVolumeFluent<?> fluent;
    Boolean validationEnabled;

    public GitRepoVolumeBuilder(){
            this(true);
    }
    public GitRepoVolumeBuilder(Boolean validationEnabled){
            this(new GitRepoVolume(), validationEnabled);
    }
    public GitRepoVolumeBuilder(GitRepoVolumeFluent<?> fluent){
            this(fluent, true);
    }
    public GitRepoVolumeBuilder(GitRepoVolumeFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new GitRepoVolume(), validationEnabled);
    }
    public GitRepoVolumeBuilder(GitRepoVolumeFluent<?> fluent,io.dekorate.kubernetes.config.GitRepoVolume instance){
            this(fluent, instance, true);
    }
    public GitRepoVolumeBuilder(GitRepoVolumeFluent<?> fluent,io.dekorate.kubernetes.config.GitRepoVolume instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withVolumeName(instance.getVolumeName()); 
            fluent.withRepository(instance.getRepository()); 
            fluent.withDirectory(instance.getDirectory()); 
            fluent.withRevision(instance.getRevision()); 
            this.validationEnabled = validationEnabled; 
    }
    public GitRepoVolumeBuilder(io.dekorate.kubernetes.config.GitRepoVolume instance){
            this(instance,true);
    }
    public GitRepoVolumeBuilder(io.dekorate.kubernetes.config.GitRepoVolume instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withVolumeName(instance.getVolumeName()); 
            this.withRepository(instance.getRepository()); 
            this.withDirectory(instance.getDirectory()); 
            this.withRevision(instance.getRevision()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableGitRepoVolume build(){
            EditableGitRepoVolume buildable = new EditableGitRepoVolume(fluent.getVolumeName(),fluent.getRepository(),fluent.getDirectory(),fluent.getRevision());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            GitRepoVolumeBuilder that = (GitRepoVolumeBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
