package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class LabelBuilder extends LabelFluentImpl<LabelBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.Label,LabelBuilder>{

    LabelFluent<?> fluent;
    Boolean validationEnabled;

    public LabelBuilder(){
            this(true);
    }
    public LabelBuilder(Boolean validationEnabled){
            this(new Label(), validationEnabled);
    }
    public LabelBuilder(LabelFluent<?> fluent){
            this(fluent, true);
    }
    public LabelBuilder(LabelFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Label(), validationEnabled);
    }
    public LabelBuilder(LabelFluent<?> fluent,io.dekorate.kubernetes.config.Label instance){
            this(fluent, instance, true);
    }
    public LabelBuilder(LabelFluent<?> fluent,io.dekorate.kubernetes.config.Label instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withKey(instance.getKey()); 
            fluent.withValue(instance.getValue()); 
            this.validationEnabled = validationEnabled; 
    }
    public LabelBuilder(io.dekorate.kubernetes.config.Label instance){
            this(instance,true);
    }
    public LabelBuilder(io.dekorate.kubernetes.config.Label instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withKey(instance.getKey()); 
            this.withValue(instance.getValue()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableLabel build(){
            EditableLabel buildable = new EditableLabel(fluent.getKey(),fluent.getValue());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            LabelBuilder that = (LabelBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
