package io.dekorate.kubernetes.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class MountFluentImpl<A extends MountFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements MountFluent<A>{

    private String name;
    private String path;
    private String subPath = "";
    private boolean readOnly = false;

    public MountFluentImpl(){
    }
    public MountFluentImpl(io.dekorate.kubernetes.config.Mount instance){
            this.withName(instance.getName()); 
            this.withPath(instance.getPath()); 
            this.withSubPath(instance.getSubPath()); 
            this.withReadOnly(instance.isReadOnly()); 
    }

    public String getName(){
            return this.name;
    }

    public A withName(String name){
            this.name=name; return (A) this;
    }

    public Boolean hasName(){
            return this.name != null;
    }

    public A withNewName(String arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuilder arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuffer arg1){
            return (A)withName(new String(arg1));
    }

    public String getPath(){
            return this.path;
    }

    public A withPath(String path){
            this.path=path; return (A) this;
    }

    public Boolean hasPath(){
            return this.path != null;
    }

    public A withNewPath(String arg1){
            return (A)withPath(new String(arg1));
    }

    public A withNewPath(StringBuilder arg1){
            return (A)withPath(new String(arg1));
    }

    public A withNewPath(StringBuffer arg1){
            return (A)withPath(new String(arg1));
    }

    public String getSubPath(){
            return this.subPath;
    }

    public A withSubPath(String subPath){
            this.subPath=subPath; return (A) this;
    }

    public Boolean hasSubPath(){
            return this.subPath != null;
    }

    public A withNewSubPath(String arg1){
            return (A)withSubPath(new String(arg1));
    }

    public A withNewSubPath(StringBuilder arg1){
            return (A)withSubPath(new String(arg1));
    }

    public A withNewSubPath(StringBuffer arg1){
            return (A)withSubPath(new String(arg1));
    }

    public boolean isReadOnly(){
            return this.readOnly;
    }

    public A withReadOnly(boolean readOnly){
            this.readOnly=readOnly; return (A) this;
    }

    public Boolean hasReadOnly(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            MountFluentImpl that = (MountFluentImpl) o;
            if (name != null ? !name.equals(that.name) :that.name != null) return false;
            if (path != null ? !path.equals(that.path) :that.path != null) return false;
            if (subPath != null ? !subPath.equals(that.subPath) :that.subPath != null) return false;
            if (readOnly != that.readOnly) return false;
            return true;
    }




}
