package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class ProbeBuilder extends ProbeFluentImpl<ProbeBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.Probe,ProbeBuilder>{

    ProbeFluent<?> fluent;
    Boolean validationEnabled;

    public ProbeBuilder(){
            this(true);
    }
    public ProbeBuilder(Boolean validationEnabled){
            this(new Probe(), validationEnabled);
    }
    public ProbeBuilder(ProbeFluent<?> fluent){
            this(fluent, true);
    }
    public ProbeBuilder(ProbeFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Probe(), validationEnabled);
    }
    public ProbeBuilder(ProbeFluent<?> fluent,io.dekorate.kubernetes.config.Probe instance){
            this(fluent, instance, true);
    }
    public ProbeBuilder(ProbeFluent<?> fluent,io.dekorate.kubernetes.config.Probe instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withHttpActionPath(instance.getHttpActionPath()); 
            fluent.withExecAction(instance.getExecAction()); 
            fluent.withTcpSocketAction(instance.getTcpSocketAction()); 
            fluent.withInitialDelaySeconds(instance.getInitialDelaySeconds()); 
            fluent.withPeriodSeconds(instance.getPeriodSeconds()); 
            fluent.withTimeoutSeconds(instance.getTimeoutSeconds()); 
            this.validationEnabled = validationEnabled; 
    }
    public ProbeBuilder(io.dekorate.kubernetes.config.Probe instance){
            this(instance,true);
    }
    public ProbeBuilder(io.dekorate.kubernetes.config.Probe instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withHttpActionPath(instance.getHttpActionPath()); 
            this.withExecAction(instance.getExecAction()); 
            this.withTcpSocketAction(instance.getTcpSocketAction()); 
            this.withInitialDelaySeconds(instance.getInitialDelaySeconds()); 
            this.withPeriodSeconds(instance.getPeriodSeconds()); 
            this.withTimeoutSeconds(instance.getTimeoutSeconds()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableProbe build(){
            EditableProbe buildable = new EditableProbe(fluent.getHttpActionPath(),fluent.getExecAction(),fluent.getTcpSocketAction(),fluent.getInitialDelaySeconds(),fluent.getPeriodSeconds(),fluent.getTimeoutSeconds());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ProbeBuilder that = (ProbeBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
