package io.dekorate.kubernetes.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class SecretVolumeBuilder extends SecretVolumeFluentImpl<SecretVolumeBuilder> implements VisitableBuilder<io.dekorate.kubernetes.config.SecretVolume,SecretVolumeBuilder>{

    SecretVolumeFluent<?> fluent;
    Boolean validationEnabled;

    public SecretVolumeBuilder(){
            this(true);
    }
    public SecretVolumeBuilder(Boolean validationEnabled){
            this(new SecretVolume(), validationEnabled);
    }
    public SecretVolumeBuilder(SecretVolumeFluent<?> fluent){
            this(fluent, true);
    }
    public SecretVolumeBuilder(SecretVolumeFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new SecretVolume(), validationEnabled);
    }
    public SecretVolumeBuilder(SecretVolumeFluent<?> fluent,io.dekorate.kubernetes.config.SecretVolume instance){
            this(fluent, instance, true);
    }
    public SecretVolumeBuilder(SecretVolumeFluent<?> fluent,io.dekorate.kubernetes.config.SecretVolume instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withVolumeName(instance.getVolumeName()); 
            fluent.withSecretName(instance.getSecretName()); 
            fluent.withDefaultMode(instance.getDefaultMode()); 
            fluent.withOptional(instance.isOptional()); 
            this.validationEnabled = validationEnabled; 
    }
    public SecretVolumeBuilder(io.dekorate.kubernetes.config.SecretVolume instance){
            this(instance,true);
    }
    public SecretVolumeBuilder(io.dekorate.kubernetes.config.SecretVolume instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withVolumeName(instance.getVolumeName()); 
            this.withSecretName(instance.getSecretName()); 
            this.withDefaultMode(instance.getDefaultMode()); 
            this.withOptional(instance.isOptional()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableSecretVolume build(){
            EditableSecretVolume buildable = new EditableSecretVolume(fluent.getVolumeName(),fluent.getSecretName(),fluent.getDefaultMode(),fluent.isOptional());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            SecretVolumeBuilder that = (SecretVolumeBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
